#!/bin/csh
# First, create the auto-reboot file 
touch ./autoreboot.flag
rm ./boot.flag

# now loop while the flag exists
# NOTE: the mud server removes the flag file initially
# but creates it after it successfully boots, thus
# preventing an infinite crash on boot problem

while (-e ./autoreboot.flag)
  ./crimson2.exe

  # First, in case this was caused by a crash, save 
  # a copy of the binary and core files...
  cp -f crimson2.exe crimson2.exe.old
  cp -f core core.old
  
  # Check for a new binary
  diff crimson2a.exe crimson2.exe
  if ($status) then
    cp -f crimson2a.exe crimson2.exe
    rm -f core
  endif

  # at this point we can check for boot.flag file
  # if it exists the server crashed while booting
  # and we should perhaps email the admins.
  #
  # if (-e ./boot.flag)
  #   more msg/crash.msg | mail cryogen@infoserve.net
  # end
end
