extern WORD AFFECT_NONE;
extern WORD AFFECT_STR;
extern WORD AFFECT_DEX;
extern WORD AFFECT_INT;
extern WORD AFFECT_WIS;
extern WORD AFFECT_CON;
extern WORD AFFECT_HIT;
extern WORD AFFECT_MOVE;
extern WORD AFFECT_POWER;
extern WORD AFFECT_ARMOR;
extern WORD AFFECT_HITROLL;
extern WORD AFFECT_DAMROLL;
extern WORD AFFECT_RES_PUNCTURE;
extern WORD AFFECT_RES_SLASH;
extern WORD AFFECT_RES_CONCUSSIVE;
extern WORD AFFECT_RES_HEAT;
extern WORD AFFECT_RES_EMR;
extern WORD AFFECT_RES_LASER;
extern WORD AFFECT_RES_PSYCHIC;
extern WORD AFFECT_RES_ACID;
extern WORD AFFECT_RES_POISON;
extern WORD AFFECT_SPEED;
extern WORD AFFECT_IRONWILL;

/* Affect flags */
#define AF_GROUP          1<<0 /* if set than thing is grouped with its leader */
#define AF_IMPROVED       1<<1 /* If set then attacking wont wear off invis */
#define AF_INVIS          1<<2 /* if set thing becomes invisible to others */
#define AF_BREATHWATER    1<<3 /* if set thing doesnt take damage underwater */
#define AF_DARKVISION     1<<4 /* if set thing can see in the dark */
#define AF_SEEINVIS       1<<5 /* if set thing can see invisible */
#define AF_REGENERATION   1<<6 /* fast regen of hit points */
#define AF_ENDURANCE      1<<7 /* half-movement cost */
#define AF_HIDDEN         1<<8 /* hiding and preparing to ambush */
#define AF_PHASEWALK      1<<9 /* No terrain costs */
#define AF_WATERWALK      1<<10 /* walk on water without a boat */
#define AF_VACUUMWALK     1<<11 /* walk in vacuum without taking damage */
#define AF_FIGHTSTART     1<<12 /* started the fight */
#define AF_DOMINATED      1<<13 /* being mind controlled */
#define AF_SNEAK          1<<14 /* sneaking */
#define AF_SENSELIFE      1<<15 /* can see hidden creatures */
#define AF_PHASEDOOR      1<<16 /* walk through doors */
#define AF_SLEEP          1<<17 /* put to sleep , wakes up if attacked */
#define AF_IMMOBILIZE     1<<18 /* cant flee or leave the room */
#define AF_MINDLINK       1<<19 /* god level snoop */
#define AF_PHANTOMEYE     1<<20 /* just see what they see */
#define AF_PHANTOMEAR     1<<21 /* just hear what they hear */
#define AF_PSI_IMMUNE     1<<22 /* totally immune to psi skills both good and bad */
#define AF_FLICKER        1<<23 /* flicker in and out of space taking less damage */

/* special durations */
#define AD_UNLIMITED      -1
#define AD_NONE           -2

struct AffectType {
  BYTE    aNum;
  BYTE    aEffect;
  WORD    aDuration;
  LWORD   aValue; /* could be a pointer */
  AFFECT *aNext;
  THING*  caster; /* added by rich */
  THING*  target; /* added by rich */
};

extern BYTE *affectList[];

#define AFFECT_CREATE 0
#define AFFECT_FREE   1
extern void AffectThing(BYTE mode, THING *thing, WORD aNum, LWORD aValue);

extern LWORD   AffectFastTick(THING *thing ); /* added by rich */

/* the following routines use AffectThing to set/remove flags and modifiers */
extern AFFECT *AffectCreate(THING *thing, WORD aNum, LWORD aValue, WORD aDuration, WORD eType);
extern void    AffectReplace(THING *thing, WORD aNum, LWORD aValue, WORD aDuration, WORD eType);
extern void    AffectApply(THING *thing, AFFECT *affect);
extern void    AffectUnapply(THING *thing, AFFECT *affect);
extern void    AffectRead(THING *thing, AFFECT *affect, FILE *file);
extern void    AffectWrite(THING *thing, AFFECT *affect, FILE *file);
extern void    AffectReadPrimitive(THING *thing, AFFECT *affect, FILE *file);
extern void    AffectWritePrimitive(THING *thing, AFFECT *affect, FILE *file);
extern void    AffectApplyAll(THING *thing);
extern void    AffectUnapplyAll(THING *thing);
extern void    AffectRemove(THING *thing, AFFECT *affect);
extern void    AffectFree(THING *thing, AFFECT *affect);
extern AFFECT *AffectFind(THING *thing, LWORD effect);
extern LWORD   AffectTick(THING *thing );