/* Crimson2 Mud Server
 * All source written/copyright Ryan Haksi 1995 *
 * This source code is proprietary. Use in whole or in part without
 * explicity permission by the author is strictly prohibited
 *
 * Current email address(es): cryogen@infoserve.net
 * Phone number: (604) 591-5295
 *
 * C4 Script Language written/copyright Cam Lesiuk 1995
 * Email: clesiuk@engr.uvic.ca
 */

/* god related commands */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#ifndef WIN32
  #include <dirent.h>
  #include <unistd.h> /* for unlink, fork, execve */
#endif
#ifdef WIN32
  #include <io.h>
#endif

#include "crimson2.h"
#include "macro.h"
#include "mem.h"
#include "log.h"
#include "dirlist.h"
#include "str.h"
#include "queue.h"
#include "send.h"
#include "ini.h"
#include "extra.h"
#include "property.h"
#include "file.h"
#include "thing.h"
#include "index.h"
#include "edit.h"
#include "history.h"
#include "socket.h"
#include "site.h"
#include "exit.h"
#include "world.h"
#include "base.h"
#include "object.h"
#include "char.h"
#include "affect.h"
#include "fight.h"
#include "mobile.h"
#include "skill.h"
#include "player.h"
#include "parse.h"
#include "help.h"
#include "area.h"
#include "cmd_talk.h"
#include "cmd_inv.h"
#include "cmd_move.h"
#include "cmd_god.h"
#include "cmd_cbt.h"
#include "effect.h"

extern LWORD SkillMaximum(THING *thing, LWORD skill, LWORD maxLevel, LWORD *gain);

/* just add/remove spells to/from this list to add/remove them from the godbless
   command
*/
BYTE* godBless[] = { "seeinvis", "strength", "dexterity", "constitution",
                     "haste", "luckyhits", "luckshield", "luckydamage",
                     "luckydodge","kinetic", "darkvision", "regene", "improved",
                     "endurance", "" };


CMDPROC( CmdGodBless ) {
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  THING *search;
  LWORD  matches = 0;
  BYTE   Index;
  BYTE   Index2;
  SOCK*  sock;
  AFFECT* affect;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  search = Base(thing)->bInside;
  found = ThingFind(srcKey, -1, search, TF_PLR|TF_PLR_WLD, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }
  while (found && srcNum!=0 ) {
    sock = BaseControlFind(found);
    /*
      dont do offline players or GODS
    */
    if( sock && !ParseCommandCheck(PARSE_COMMAND_WGOTO, sock , "") ) {
      SendThing("^bYou God Bless ^g", thing);
      SendThing(found->tSDesc->sText, thing);
      SendThing("\n", thing);
      SendAction("$n God Blesses you\n", thing, found, SEND_DST|SEND_CAPFIRST);
      SendAction("$n God Blesses $N\n", thing, found, SEND_ROOM|SEND_CAPFIRST);
      for( Index = 0; godBless[Index][0]; Index++ ) {      
        Index2 = TYPEFIND( godBless[Index], psiList);
        Effect( *psiList[Index2].pEffect, TAR_PLR_WLD|TAR_PLR_ROOM, thing, found->tSDesc->sText, 150 );
        for (affect=Character(found)->cAffect; affect; affect=affect->aNext) {
          if (affect->aEffect == *psiList[Index2].pEffect ) {
            affect->aDuration = 100;
          }
        }
      }
      matches++;
    }
    /* see if there is more (will not find successive matches unless offset is TF_ALLMATCH) */
    found = ThingFind(srcKey, -1, search, TF_PLR|TF_PLR_WLD|TF_CONTINUE, &srcOffset);
    if (srcNum>0) srcNum--;
  }
  sprintf( srcKey, "You God Blessed %lu Players.\n", matches );
  SendAction( srcKey, thing, NULL, SEND_SRC|SEND_AUDIBLE|SEND_CAPFIRST);  
}

CMDPROC(CmdDispel) { /* void CmdProc(THING *thing, BYTE* cmd) */
  AFFECT* affect;
  AFFECT* next;
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  LWORD  matches = 0;
  THING *found;
  THING *search;
  BASELINK *baseLink = NULL;  
  BYTE    link;
  SOCK * sock;
  /*
     we dont want to touch anything below BL_TELEPATHY_SND
     I dont know about the C4 ones leave em alone for now     
  */
#define MAX_BL 6 /* be less then this actually */
  WORD linkTypes[] = { BL_TELEPATHY_SND, BL_TELEPATHY_RCV, BL_HEAR_SND ,
                       BL_HEAR_RCV, BL_SEE_SND, BL_SEE_RCV, BL_C4_SND, BL_C4_RCV  };

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  search = Base(thing)->bInside;
  found = ThingFind(srcKey, -1, search, TF_PLR|TF_PLR_WLD, &srcOffset);
  if (!found) {    
    SendAction( "^bThere doesnt appear to be anything like that around\n", thing, NULL, SEND_SRC|SEND_AUDIBLE|SEND_CAPFIRST);
    return;
  }
  while (found && srcNum!=0) {
    SendAction("^bYou Dispel all affects from ^g$N\n",thing,found, SEND_SRC|SEND_AUDIBLE|SEND_CAPFIRST);
    SendAction("^b$n Dispels all affects from you\n", thing, found, SEND_DST|SEND_AUDIBLE|SEND_CAPFIRST);
    SendAction("^b$n Dispels all affects from $N\n", thing, found, SEND_ROOM|SEND_AUDIBLE|SEND_CAPFIRST);
    for (affect=Character(found)->cAffect; affect; affect = next ) {
      next = affect->aNext;
      AffectRemove( found, affect);
    }
    /* for now at least handle snoops ( not from gods ) here also */
    for( link = 0; link < MAX_BL; link++ ) {
      baseLink = BaseLinkFind( Base(found)->bLink , linkTypes[link] , NULL );
      if( baseLink ) {
        search = baseLink->lDetail.lThing;
        sock = BaseControlFind( search );
        if( search && !ParseCommandCheck(PARSE_COMMAND_WGOTO, sock , "") ) {
          BaseLinkFree( found, baseLink );
        }
      }
    }
    matches++;
    /* see if there is more (will not find successive matches unless offset is TF_ALLMATCH) */
    found = ThingFind(srcKey, -1, search, TF_PLR|TF_PLR_WLD|TF_CONTINUE, &srcOffset);
    if (srcNum>0) srcNum--;
  }
  sprintf( srcKey, "You Dispelled all Affects from %lu Players.\n", matches );
  SendAction( srcKey, thing, NULL, SEND_SRC|SEND_AUDIBLE|SEND_CAPFIRST);
}

/* make.output */
CMDPROC( CmdMakeOutPut ) {
  FILE * file = fopen( "make.output" , "r" );
  BYTE buf[81];

  if( !file ) {
    SendThing("^bError opening makefile output, file not found.^g", thing);
    return;
  }
  while( !feof( file ) ) {
    if( fgets( buf, 80,file ) )
      SendThing( buf, thing );
  }
  fclose( file );
}

CMDPROC( CmdGodSkill ) {
  LWORD i;
  LWORD  max;
  BYTE   srcKey[256];
  BYTE   word[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  THING *search;
  SOCK* sock;
  BYTE   online = TRUE;
  BYTE   usermsg[256];
  BYTE   godmsg[256];

  cmd = StrOneWord( cmd, NULL ); /* lose the command at the start */  
  cmd = StrOneWord(cmd, word);     
  if( *word ) {
    cmd = ParseFind(word, srcKey, &srcOffset, &srcNum, NULL, NULL);
    search = Base(thing)->bInside;
    found = ThingFind(srcKey, -1, search, TF_PLR|TF_PLR_WLD, &srcOffset);
    if (!found) {      
      found = PlayerRead( word, PREAD_NORMAL );
      online = FALSE;
      if( !found ) {
        SendThing("^bThere doesnt appear to be anything like that around\n", thing);
        return;
      }
    }
  } else {
    found = thing;
  }  
  sprintf(word,"^bGSkill ^g%s", found->tSDesc->sText );
  if( !online )
    strcat( word,"^g (^rOFFLINE^g)" );  
  sprintf( godmsg, "^GGOD: ^g%s^g - %s\n", thing->tSDesc->sText, word );
  sprintf( usermsg, "^gYou %s\n", word ); 
  SendChannel(godmsg,NULL,SP_CHANGOD);
  SendThing( usermsg, thing );
  sock = BaseControlFind( found );
  for(i=1; *skillList[i].sName; i++) {
    if( online && sock && ParseCommandCheck(PARSE_COMMAND_WGOTO, sock , "") ) {
      max = 500;
    } else {
      if( Character( found )->cLevel >= LEVEL_GOD )
        max = 500;
      else
        max = SkillMaximum(found, i, 0, NULL);
    }
    Plr(found)->pSkill[i] = max;
  }
  if( !online ) {
    PlayerWrite( found, PWRITE_PLAYER );
    THINGFREE( found ); /* not sure if this is necessary or not */
  }
}

CMDPROC(CmdHeal) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  THING *search;
  LWORD  matches = 0;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  search = Base(thing)->bInside;
  found = ThingFind(srcKey, -1, search, TF_PLR|TF_PLR_ANYWHERE, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }
  while (found && srcNum!=0) {
    SendThing("^bYou heal ^g", thing);
    SendThing(found->tSDesc->sText, thing);
    SendThing("\n", thing);
    SendAction("$n heals you\n", thing, found, SEND_DST|SEND_CAPFIRST);
    SendAction("$n heals $N\n", thing, found, SEND_ROOM|SEND_CAPFIRST);
    Character(found)->cHitP   = CharGetHitPMax(found);
    Character(found)->cMoveP  = CharGetMovePMax(found);
    Character(found)->cPowerP = CharGetPowerPMax(found);
    matches++;
    /* see if there is more (will not find successive matches unless offset is TF_ALLMATCH) */
    found = ThingFind(srcKey, -1, search, TF_PLR|TF_PLR_ANYWHERE|TF_CONTINUE, &srcOffset);
    if (srcNum>0) srcNum--;
  }
  sprintf( srcKey, "You Healed %lu Players.\n", matches );
  SendAction( srcKey, thing, NULL, SEND_SRC|SEND_AUDIBLE|SEND_CAPFIRST);
}

CMDPROC(CmdPurge) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  THING *search;
  
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  search = Base(thing)->bInside;
  found = ThingFind(srcKey, -1, search, TF_OBJ|TF_MOB, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }

  while (found && srcNum!=0) {
    SendThing("^bYou blast ^g", thing);
    SendThing(found->tSDesc->sText, thing);
    SendThing("^b right out of existence\n", thing);
    SendAction("$n blasts $N right out of existence\n", thing, found, SEND_ROOM|SEND_AUDIBLE|SEND_CAPFIRST);    
    ThingExtract(found);
    ThingFree(found);
    /* see if there is more (will not find successive matches unless offset is TF_ALLMATCH) */
    found = ThingFind(srcKey, -1, search, TF_OBJ|TF_MOB|TF_CONTINUE, &srcOffset);
    if (srcNum>0) srcNum--;
  }
}

CMDPROC(CmdTransfer) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  BYTE   dstKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  LWORD  dstOffset;
  THING *found;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, dstKey, &dstOffset);
  MAXSET(srcNum, 100); /* after that things could get crowded */


  /* Set to ignore matches in the same room as us */
  if (!STRICMP(srcKey, "all"))
    found = ThingFind(srcKey, -1, Base(thing)->bInside, TF_PLR_WLD, &srcOffset);
  else
    found = ThingFind(srcKey, -1, Base(thing)->bInside, TF_PLR_WLD|TF_OBJ_WLD|TF_MOB_WLD, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }

  while (found && srcNum!=0) {
    SendThing("^bYou transfer ^g", thing);
    SendThing(found->tSDesc->sText, thing);
    SendThing("\n", thing);
    SendAction("$n idly waves $s hand and summons $N\n", thing, found, SEND_ROOM|SEND_AUDIBLE|SEND_CAPFIRST);
    SendAction("$n rips apart space and time and suddenly you are elsewhere\n", thing, found, SEND_DST |SEND_AUDIBLE|SEND_CAPFIRST);
    SendAction("$N rips apart space and time and suddenly $n is gone\n", found, thing, SEND_ROOM |SEND_AUDIBLE|SEND_CAPFIRST);
    ThingTo(found, Base(thing)->bInside);
    CmdLook(found, "");

    /* see if there is more (will not find successive matches unless offset is TF_ALLMATCH) */
    if (!STRICMP(srcKey, "all"))
      found = ThingFind(srcKey, -1, Base(thing)->bInside, TF_PLR_WLD|TF_CONTINUE, &srcOffset);
    else
      found = ThingFind(srcKey, -1, Base(thing)->bInside, TF_PLR_WLD|TF_OBJ_WLD|TF_MOB_WLD|TF_CONTINUE, &srcOffset);
    if (srcNum>0) srcNum--;
  }
}

CMDPROC(CmdSetSkill) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  BYTE   buf[256];
  BYTE   truncateStr[256];
  LWORD  i;
  LWORD  skill;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (!*cmd) { /* if they didnt type anything, give 'em a list */
    SendThing("^pUsage:\n^P=-=-=-=\n", thing);
    SendThing("^cSETSKILL <Target> <0-255>\n", thing);
    SendThing("\n^gAvailable Skills:\n^G=-=-=-=-= -=-=-=-\n^c", thing);
    for (i=0; *skillList[i].sName; i++) {
      sprintf(buf, "%-19s", StrTruncate(truncateStr,skillList[i].sName, 19));
      SendThing(buf, thing);
      if (i%4 == 3)
        SendThing("\n", thing);
      else
        SendThing(" ", thing);
    }
    if (i%4)
      SendThing("\n", thing); /* last line allways gets a return */
    sprintf(buf, "^g%ld ^bskills listed.\n", i);
    SendThing(buf, thing);
    return;
  }

  cmd = cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);
  found = ThingFind(srcKey, -1, NULL, TF_PLR_WLD, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }

  if (!(*cmd)) {
    /* show them "found"'s current skills */
    SkillShow(found,thing,"*ALL*", 0xFFFFFFFF,0,0);
    return;
  } 
  cmd = StrOneWord(cmd, buf); /* get the word in question */
  i = TYPEFIND(buf, skillList);
  if (i == -1) { 
    SendThing("^wOh, good one.... I bet you made that up on the spot, didnt you?\n", thing);
    return;
  }
  cmd = StrOneWord(cmd, buf); /* what shall we set it to */
  skill = atoi(buf);
  sprintf(buf,
    "^rYou have changed %s's skill '%s' from %ld to %ld\n",
    found->tSDesc->sText,
    skillList[i].sName,
    (LWORD)Plr(found)->pSkill[i],
    skill);
  Plr(found)->pSkill[i] = skill;
  SendThing(buf, thing);

  sprintf(buf,
    "^r$n has changed your skill at '%s' from %ld to %ld\n",
    skillList[i].sName,
    (LWORD)Plr(found)->pSkill[i],
    skill);
  SendAction(buf, thing, found, SEND_DST |SEND_AUDIBLE|SEND_CAPFIRST);
}

CMDPROC(CmdSetStat) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE         srcKey[256];
  LWORD        srcNum;
  LWORD        srcOffset;
  THING       *found;
  BYTE         buf[512];
  BYTE         setWord[256];
  LWORD        i;
  CHARACTER    character;
  PLR          player;
  LWORD        readPlayer = FALSE;
  SOCK        *sockThing;
  SOCK        *sockFound;
  LWORD        thingLevel;
  
  /* I do this instead of using the regular pSystemList because
   * I don't want ppl to be bothered by things they shouldn't be
   * bothered by, like CRASHSAVED!  */
  BYTE        *localSystemList[] = {
    " ", /* LOG */
    "KILLER",
    "HELPER",
    " ",     /* CRASHSAVED */
    "NOHASSLE",
    "GODINVIS",
    "TESTER",
    "NOSUMMON",
    "NOSPAM",
    "ENFORCER",
    "CODER",
    ""
};

  SETLIST statSetList[] = {
    { "LEVEL",        SET_NUMERIC(character,character.cLevel)                  },
    { "EXPERIENCE",   SET_NUMERIC(character,character.cExp)                    },
    { "AURA",         SET_NUMERIC(character,character.cAura)                   },
    { "MONEY",        SET_NUMERIC(character,character.cMoney)                  },
    { "BANK",         SET_NUMERIC(player,   player.pBank)                      },
    { "SEX",          SET_TYPE(   character,character.cSex, sexList)           },
    { "POSITION",     SET_TYPE(   character,character.cPos, posList)           },
    { "AFFECTFLAG",   SET_TYPE(   character,character.cAffectFlag, affectList) },
    { "HITP",         SET_NUMERIC(character,character.cHitP)                   },
    { "MOVEP",        SET_NUMERIC(character,character.cMoveP)                  },
    { "POWERP",       SET_NUMERIC(character,character.cPowerP)                 },
    { "HITPMAX",      SET_NUMERIC(character,character.cHitPMax)                },
    { "MOVEPMAX",     SET_NUMERIC(player,   player.pMovePMax)                  },
    { "POWERPMAX",    SET_NUMERIC(player,   player.pPowerPMax)                 },
    { "STRENGTH",     SET_NUMERIC(player,   player.pStr)                       },
    { "INTELLIGENCE", SET_NUMERIC(player,   player.pInt)                       },
    { "WISDOM",       SET_NUMERIC(player,   player.pWis)                       },
    { "DEXTERITY",    SET_NUMERIC(player,   player.pDex)                       },
    { "CONSTITUTION", SET_NUMERIC(player,   player.pCon)                       },
    { "PRACTICES",    SET_NUMERIC(player,   player.pPractice)                  },
    { "HUNGER",       SET_NUMERIC(player,   player.pHunger)                    },
    { "THIRST",       SET_NUMERIC(player,   player.pThirst)                    },
    { "INTOXICATION", SET_NUMERIC(player,   player.pIntox)                     },
    { "PASSWORD",     SET_STR(player,       player.pPassword)                  },
/* This was useless except for the "LOG" flag, which is now accessed
 * via the "log" command */
/*     { "SYSTEMFLAG",   ST_FLAG(   player,   player.pSystem, localSystemList)       }, */
    { "HELPER",       SET_FLAG(   player,   player.pSystem, localSystemList)       },
    { "TESTER",       SET_FLAG(   player,   player.pSystem, localSystemList )       },
    { "AUTOACTION",   SET_FLAG(   player,   player.pAuto, pAutoList)           },
    { "KILLER",       SET_FLAG(   player,   player.pSystem, localSystemList )       },
    { "ENFORCER",     SET_FLAG(   player,   player.pSystem, localSystemList )       },
    { "NOSPAM",       SET_FLAG(   player,   player.pSystem, localSystemList )       },
    { "NOSUMMON",     SET_FLAG(   player,   player.pSystem, localSystemList )       },
    { "CODER",        SET_FLAG(   player,   player.pSystem, localSystemList )       },
    { "" }
  };

  cmd = StrOneWord(cmd, NULL);
  if (!*cmd) { /* if they didnt type anything, give 'em a list */
    SendThing("\n^pUsuage:\n^P=-=-=-=\n", thing);
    SendThing("^pSETSTAT <player> <stat> <value>\n", thing);
    EditSet(thing, cmd, NULL, NULL, statSetList);
    return;
  }

  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);
  found = ThingFind(srcKey, -1, NULL, TF_PLR_WLD, &srcOffset);
  if (!found) {
    found = PlayerRead(srcKey, PREAD_NORMAL);
    readPlayer = TRUE;
  }
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }


  do {
    /* Note by Cryogen: should actually take the first keyword, but this
     * seems to mostly work. Actually should split off the 
     * statting code into its own routine so you can pass it the pointer */
    if (!*cmd) { /* provide help - stat this "found" item */
      sprintf(buf,"stat %s",Thing(found)->tSDesc->sText);
      CmdStat(thing,buf);
      break;
    }
  
    sockFound=BaseControlFind(found);
    sockThing=BaseControlFind(thing);
    if ((sockFound)&&(sockThing)&&(sockFound!=sockThing)&&
        (Character(sockFound->sHomeThing)->cLevel>=
         Character(sockThing->sHomeThing)->cLevel)) {
      SendThing("^wYou can't setstat other players who are the same level or higher than you!!\n", thing);
      break;
    }
 
    if (sockThing) {
      /* we have to store the level now BEFORE we do the change because they 
       * may be trying to change their OWN level to something above what they
       * are allowed. */
      thingLevel=Character(sockThing->sHomeThing)->cLevel;
    } 

    StrOneWord(cmd, setWord); /* get the word in question */
    if( StrAbbrev( "CODER", setWord ) &&
        !ParseCommandCheck(PARSE_COMMAND_SECURITY, sockThing, "" )) {
      SendAction("^cI'm afraid you're not authorized to do that\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
      return;
    }        

    i = EditSet(thing, cmd, found, found->tSDesc->sText, statSetList);
    if (i==-1) {
      SendThing("^wOh, good one.... I bet you made that stat up on the spot, didnt you?\n", thing);
      SendThing("^wType SETSTAT with no arguments for a list of changeable stats\n", thing);
      break;
    } else if (i == 1) {
      /* something changed alert the target */
      sprintf(buf,
        "^r$n has performed a Setstat on you: '%s'\n",
        cmd);
      SendAction(buf, thing, found, SEND_DST|SEND_CAPFIRST);

      /* Level check - this hack makes sure they don't set someone's (or their own) level to a 
       * level higher than their own current level. */
      if ( (sockFound)&&(sockThing)&&(Character(sockFound->sHomeThing)->cLevel>thingLevel) ) {
        SendAction("^wYou cannot set anyone's level higher than your own current level.\n", thing, found, SEND_SRC|SEND_CAPFIRST);
        sprintf(buf,"^w$N's level capped at %li\n",thingLevel);
        SendAction(buf, thing, found, SEND_SRC|SEND_DST|SEND_CAPFIRST);
        Character(sockFound->sHomeThing)->cLevel=thingLevel;
      }

      /* Special requirement, password is stored encrypted */
      i = TYPEFIND(setWord, statSetList);
      if (i!=-1 && !strcmp("PASSWORD", statSetList[i].sName)) {
        STR *oldPW;
    
        /* Crypt the password */
        oldPW = Plr(found)->pPassword;
        Plr(found)->pPassword = STRCREATE(CRYPT(oldPW->sText, getenv("CRIMSON2CRYPTKEY")));
        STRFREE(oldPW);
      }

    }
  } while(0);

  if (readPlayer) {
    PlayerWrite(found, PWRITE_PLAYER);
    THINGFREE(found);
  }
}

/* modify a property on the fly */
CMDPROC(CmdSetProp) {
  BYTE         buf[256];
  BYTE         srcKey[256];
  LWORD        srcNum;
  LWORD        srcOffset;
  THING       *found;
  SOCK        *sock;
  PROPERTY    *property;

  sock = BaseControlFind(thing);
  if (!sock) return;
  
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (!*cmd) {
    SendThing("^bTry ^gSETPROPERTY <thing> <property> <value> ^b- set mob/obj/player\n", thing);
    SendThing("^bor  ^gSETPROPERTY . <property> <value>       ^b- set current room\n", thing);
    return;
  }

  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);
  if (StrExact(srcKey, "."))
    found = Base(thing)->bInside;
  else
    found = ThingFind(srcKey, -1, Base(thing)->bInside->tContain, TF_MOB|TF_OBJ|TF_PLR_WLD, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }

  /* No property selected */
  if (!*cmd) {
    SendThing("^bYou have to specifiy a property name you know\n", thing);
    return;
  }
  cmd = StrOneWord(cmd, buf); /* lose the command at the start */

  if (buf[0]=='@') {
    SendThing("^bYou cannot use this command to change C4 scripts.\n", thing);
    return;
  }

  property = PropertyFind(thing->tProperty, buf);
  if (*cmd) {
    if (property) {
      STRFREE(property->pDesc);
      property->pDesc = STRCREATE(cmd);
    } else {
      thing->tProperty = PropertyCreate(thing->tProperty, STRCREATE(buf), STRCREATE(cmd));
      property = thing->tProperty;
    }

    SendThing("Property Set!\n", thing);
    SendThing("^cKey: ^g", thing);
    SendThing(property->pKey->sText, thing);
    SendThing("\n^b", thing);
    SendThing(property->pDesc->sText, thing);
    SendThing("\n", thing);
  } else {
    if (property) {
      thing->tProperty = PropertyFree(thing->tProperty, property);
      SendThing("Property Deleted!\n", thing);
    } else {
      SendThing("No such property exists!\n", thing);
    }
  }
}


CMDPROC(CmdGoto) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  found = ThingFind(srcKey, -1, NULL, TF_WLD|TF_PLR_WLD|TF_OBJ_WLD|TF_MOB_WLD, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }

  SendThing("^bYou goto ^g", thing);
  SendThing(found->tSDesc->sText, thing);
  SendThing("\n", thing);
  if (thing->tType==TTYPE_PLR)
    SendAction(Plr(thing)->pExit->sText, thing, NULL, SEND_ROOM|SEND_VISIBLE);
  else
    SendAction("$n dissolves into a cloud of blue sparkles.\n", thing, NULL, SEND_ROOM|SEND_VISIBLE);
  if (found->tType == TTYPE_WLD)
    ThingTo(thing, found);
  else 
    ThingTo(thing, Base(found)->bInside);
  FightStop(thing);
  if (thing->tType==TTYPE_PLR)
    SendAction(Plr(thing)->pEnter->sText, thing, NULL, SEND_ROOM|SEND_VISIBLE);
  else
    SendAction("$n appears from a cloud of blue sparkles.\n", thing, NULL, SEND_ROOM|SEND_VISIBLE);
  CmdLook(thing, "");
}

CMDPROC(CmdVNum) { /* (BYTE *cmd, THING *thing) */
  LWORD area;
  LWORD i;
  BYTE  buf[256];
  
  cmd = StrOneWord(cmd, buf); /* buf = cmd */
  cmd = StrOneWord(cmd, buf); /* buf = mobile|object */
  if (!StrAbbrev("mobile",buf) && !StrAbbrev("object",buf) && !StrAbbrev("world",buf)) {
    SendThing("^cUSUAGE: vnum <\"object\" | \"mobile\" | \"world\"> <key>\n", thing);
    return;
  }
  if (!*cmd) {
    SendThing("^cUSUAGE: vnum <\"object\" | \"mobile\" | \"world\"> <key>\n", thing);
    return;
  }
  
  /* show matching mobs */
  if (StrAbbrev("mobile",buf)) {
    for (area=0; area<areaListMax; area++) {
      for (i=0; i<areaList[area].aMobIndex.iNum; i++) {
        if (StrIsKey(cmd, MobTemplate(areaList[area].aMobIndex.iThing[i])->mKey)) {
          sprintf(buf, 
                  "^c%5ld - ^g%s ^w[%ld]\n", 
                  MobTemplate(areaList[area].aMobIndex.iThing[i])->mVirtual,
                  MobTemplate(areaList[area].aMobIndex.iThing[i])->mSDesc->sText,
                  MobTemplate(areaList[area].aMobIndex.iThing[i])->mOnline);
          SendThing(buf, thing);
        }
      }
    }
  
  /* show matching objects */
  } else if (StrAbbrev("object",buf)) {
    for (area=0; area<areaListMax; area++) {
      for (i=0; i<areaList[area].aObjIndex.iNum; i++) {
        if (StrIsKey(cmd, ObjTemplate(areaList[area].aObjIndex.iThing[i])->oKey)) {
          sprintf(buf, 
                  "^c%5ld - ^g%s ^w[%ld+%ld]\n", 
                  ObjTemplate(areaList[area].aObjIndex.iThing[i])->oVirtual,
                  ObjTemplate(areaList[area].aObjIndex.iThing[i])->oSDesc->sText,
                  ObjTemplate(areaList[area].aObjIndex.iThing[i])->oOnline,
                  ObjTemplate(areaList[area].aObjIndex.iThing[i])->oOffline);
          SendThing(buf, thing);
        }
      }
    }
  
  /* show matching worlds */
  } else if (StrAbbrev("world",buf)) {
    for (area=0; area<areaListMax; area++) {
      for (i=0; i<areaList[area].aWldIndex.iNum; i++) {
        if (StrIsKey(cmd, Thing(areaList[area].aWldIndex.iThing[i])->tSDesc)) {
          sprintf(buf, 
                  "^c%5ld - ^g%s\n", 
                  Wld(areaList[area].aWldIndex.iThing[i])->wVirtual,
                  Thing(areaList[area].aWldIndex.iThing[i])->tSDesc->sText);
          SendThing(buf, thing);
        }
      }
    }
  }
  
}

CMDPROC(CmdStat) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE         srcKey[256];
  LWORD        srcNum;
  LWORD        srcOffset;
  THING       *found;
  BYTE         buf[256];
  BYTE         eName[256];
  BYTE         truncateStr[256];
  LWORD        i;
  EXTRA       *extra;
  PROPERTY    *property;
  EXIT        *exit;
  OBJTEMPLATE *object;
  BASELINK    *link;
  LWORD        readPlayer = FALSE;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (*cmd) {
    cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);
    found = ThingFind(srcKey, -1, NULL, TF_PLR_ANYWHERE|TF_OBJ_ANYWHERE|TF_MOB_ANYWHERE, &srcOffset);
    if (!found) {
      found = PlayerRead(srcKey, PREAD_SCAN);
      readPlayer = TRUE;
    }
    if (!found) {
      SendThing("^bThere doesnt appear to be anything like that around\n", thing);
      return;
    }
  } else
    found = Base(thing)->bInside;

  /* show them the stats */
  SendThing("^gSDesc:^G[^c", thing);
  SendThing(found->tSDesc->sText, thing);
  SendThing("^G]\n", thing);
  if (found->tType >= TTYPE_BASE) {
    SendThing("^gLDesc: ^c", thing);
    SendThing(Base(found)->bLDesc->sText, thing);
  }
  SendThing("\n^gDescription:^b\n", thing);
  SendThing(found->tDesc->sText, thing);

  switch (found->tType) {

  case TTYPE_WLD:
    sprintf(buf, "^g#:^G[%ld] ^gType:^G[^c", Wld(found)->wVirtual);
    SendThing(buf, thing);
    SendThing(TYPESPRINTF(buf, Wld(found)->wType, wTypeList, 512), thing);
    SendThing("^G]\n", thing);
    /* 2nd line - flags */
    SendThing("^gFlags: ^G[^c", thing);
    SendThing(FlagSprintf(buf, Wld(found)->wFlag, wFlagList, ' ', 512), thing);
    SendThing("^G]\n", thing);
    SendThing("^gExits:\n", thing);
    for (exit = Wld(found)->wExit; exit; exit=exit->eNext) {
      ExitGetName(exit, eName);
      sprintf(buf, "^G[^c%-5s^G] ^gto room", eName);
      SendThing(buf, thing);
      if (!exit->eWorld) {
        SendThing("^G[^c NULL^G]", thing);
      } else {
        sprintf(buf, "^G[^w%5ld^G]", Wld(exit->eWorld)->wVirtual);
        SendThing(buf, thing);
      }
      SendThing("^g, eFlags:^G[^b", thing);
      SendThing(FlagSprintf(buf, exit->eFlag, eFlagList, ' ', 512), thing);
      SendThing("^G]\n", thing);
      if (exit->eKeyObj!=-1 || exit->eKey->sText[0]) {
        sprintf(buf, "^gKey:^G[^b%5ld^G] ^gKeywords:^G[^b", exit->eKeyObj);
        SendThing(buf, thing);
        SendThing(exit->eKey->sText, thing);
        SendThing("^G]\n", thing);
      }
    }
    break;

  case TTYPE_OBJ:
    object = Obj(found)->oTemplate;
    sprintf(buf, "^g#:^G[%ld] ^gOnline^G[^c%ld^G] ^gOffline^G[^c%ld^G] ^gType:^G[^c", object->oVirtual, object->oOnline, object->oOffline);
    SendThing(buf, thing);
    SendThing(TYPESPRINTF(buf, object->oType, oTypeList, 512), thing);
    SendThing("^G]\n^gKeywords:^G[^c", thing);
    SendThing(Base(found)->bKey->sText, thing);
    SendThing("^G]\n^gEquipped As: ^G[^c", thing);
    SendThing(FlagSprintf(buf, Obj(found)->oEquip, equipList, ' ', 512), thing);
    SendThing("^G]\n^gAct: ^G[^c", thing);
    SendThing(FlagSprintf(buf, Obj(found)->oAct, oActList, ' ', 512), thing);
    SendThing("^G]\n^gWear: ^G[^c", thing);
    SendThing(TYPESPRINTF(buf, object->oWear, wearList, 512), thing);
    SendThing("^G]\n", thing);
    sprintf(buf, "^gWeight:^G[^c%hd^G] ", object->oWeight);
    SendThing(buf, thing);
    sprintf(buf, "^gValue:^G[^c%ld^G] ", object->oValue);
    SendThing(buf, thing);
    sprintf(buf, "^gRent:^G[^c%ld^G]\n", object->oRent);
    SendThing(buf, thing);
    SendThing("^gType-Specific Information\n", thing);
    for (i=0;  
         i<OBJECT_MAX_FIELD 
         && ObjectGetFieldStr(object->oType, &Obj(found)->oDetail, i, buf, 512); 
         i++) {
      SendThing(buf, thing);
    }
    for (i=0; i<OBJECT_MAX_APPLY; i++) {
      if (!Obj(found)->oApply[i].aType) break;
      SendThing("^gApply:^G[^c", thing);
      SendThing(TYPESPRINTF(buf, Obj(found)->oApply[i].aType, applyList, 512), thing);
      sprintf(buf, "^G] ^gValue:^G[^c%hd^G]\n", (WORD)Obj(found)->oApply[i].aValue);
      SendThing(buf, thing);
    }
    break;

  case TTYPE_MOB:
    sprintf(buf, "^g#:^G[%ld] ^gOnline^G[^c%ld^G] ^gAct:^G[^c", Mob(found)->mTemplate->mVirtual, Mob(found)->mTemplate->mOnline);
    SendThing(buf, thing);
    SendThing(FlagSprintf(buf, Mob(found)->mTemplate->mAct, mActList, ' ', 512), thing);
    SendThing("^G]\n", thing);
    SendThing("^gAffect: ^G[^c", thing);
    SendThing(FlagSprintf(buf, Character(found)->cAffectFlag, affectList, ' ', 512), thing);
    SendThing("^G]\n", thing);
    sprintf(buf, "^gAura:^G[^c%hd^G] ", Character(found)->cAura);
    SendThing(buf, thing);
    sprintf(buf, "^gLevel:^G[^c%hd^G] ", Character(found)->cLevel);
    SendThing(buf, thing);
    sprintf(buf, "^gHit Bonus:^G[^c%ld^G] ", CharGetHitBonus(found, Character(found)->cWeapon));
    SendThing(buf, thing);
    sprintf(buf, "^gDam Bonus:^G[^c%ld^G] ", CharGetDamBonus(found, Character(found)->cWeapon));
    SendThing(buf, thing);
    sprintf(buf, "^gArmor:^G[^c%hd^G]\n", Character(found)->cArmor);
    SendThing(buf, thing);
    sprintf(buf, "^gHP:^G[^c%ld^G/^c%ld^g] ", Character(found)->cHitP, CharGetHitPMax(found));
    SendThing(buf, thing);
    sprintf(buf, "^gMV:^G[^c%ld^G/^c%ld^g] ", Character(found)->cMoveP, CharGetMovePMax(found));
    SendThing(buf, thing);
    sprintf(buf, "^gPP:^G[^c%ld^G/^c%ld^g]\n", Character(found)->cPowerP, CharGetPowerPMax(found));
    SendThing(buf, thing);
    sprintf(buf, "^gBare-Handed Damage:^G[^c%hd^gD^c%hd+%hd^G]\n", 
      Mob(found)->mTemplate->mDamDiceNum, 
      Mob(found)->mTemplate->mDamDiceSize, 
      Mob(found)->mTemplate->mDamBonus);
    SendThing(buf, thing);
    sprintf(buf, "^gMoney:^G[^c%ld^G] ", Character(found)->cMoney);
    SendThing(buf, thing);
    sprintf(buf, "^gExp:^G[^c%ld^G] ", Character(found)->cExp);
    SendThing(buf, thing);
    SendThing("^gPos:^G[^c", thing);
    SendThing(TYPESPRINTF(buf, Character(found)->cPos, posList, 512), thing);
    SendThing("^G] ^gType:^G[^c", thing);
    SendThing(TYPESPRINTF(buf, Mob(found)->mTemplate->mType, mTypeList, 512), thing);
    SendThing("^G] ^gSex:^G[^c", thing);
    SendThing(TYPESPRINTF(buf, Character(found)->cSex, sexList, 512), thing);
    SendThing("^G]\n", thing);
    break;
    
  case TTYPE_PLR:
    SendThing("^gAffect: ^G[^c", thing);
    SendThing(FlagSprintf(buf, Character(found)->cAffectFlag, affectList, ' ', 512), thing);
    SendThing("^G]\n", thing);
    SendThing("^gHas Equip:  ^G[^c", thing);
    SendThing(FlagSprintf(buf, Character(found)->cEquip, equipList, ' ', 512), thing);
    SendThing("^G]\n", thing);
    SendThing("^gClass:^G[", thing);
    SendThing(TYPESPRINTF(buf, Plr(found)->pClass, classList, sizeof(buf)), thing);
    SendThing("^G] ^gRace:^G[", thing);
    SendThing(TYPESPRINTF(buf, Plr(found)->pRace, raceList, sizeof(buf)), thing);
    SendThing("^G]\n", thing);
    sprintf(buf, "^gAura:^G[^c%hd^G] ", Character(found)->cAura);
    SendThing(buf, thing);
    sprintf(buf, "^gLevel:^G[^c%hd^G] ", Character(found)->cLevel);
    SendThing(buf, thing);
    sprintf(buf, "^gHit Bonus:^G[^c%ld^G] ", CharGetHitBonus(found, Character(found)->cWeapon));
    SendThing(buf, thing);
    sprintf(buf, "^gDam Bonus:^G[^c%ld^G] ", CharGetDamBonus(found, Character(found)->cWeapon));
    SendThing(buf, thing);
    sprintf(buf, "^gArmor:^G[^c%hd^G]\n", Character(found)->cArmor);
    SendThing(buf, thing);
    sprintf(buf, "^gHP:^G[^c%ld^G/^c%ld^g] ", Character(found)->cHitP, CharGetHitPMax(found));
    SendThing(buf, thing);
    sprintf(buf, "^gMV:^G[^c%ld^G/^c%ld^g] ", Character(found)->cMoveP, CharGetMovePMax(found));
    SendThing(buf, thing);
    sprintf(buf, "^gPP:^G[^c%ld^G/^c%ld^g]\n", Character(found)->cPowerP, CharGetPowerPMax(found));
    SendThing(buf, thing);
    sprintf(buf, 
            "^gStr:^G[^c%hd^G] ^gWis:^G[^c%hd^G] ^gInt:^G[^c%hd^G] ^gDex:^G[^c%hd^G] ^gCon:^G[^c%hd^G]\n",
            Plr(found)->pStr,
            Plr(found)->pWis,
            Plr(found)->pInt,
            Plr(found)->pDex,
            Plr(found)->pCon);
    SendThing(buf, thing);
    sprintf(buf, 
            "^gResist:^GPU[^c%hd^G] ^GSL[^c%hd^G] ^GCO[^c%hd^G] ^GHT[^c%hd^G] ^GEMR[^c%hd^G] ^GLAS[^c%hd^G] ^GPSY[^c%hd^G] ^GACID[^c%hd^G] ^GPOI[^c%hd^G]\n",
            CharGetResist(found, FD_PUNCTURE),
            CharGetResist(found, FD_SLASH),
            CharGetResist(found, FD_CONCUSSIVE),
            CharGetResist(found, FD_HEAT),
            CharGetResist(found, FD_EMR),
            CharGetResist(found, FD_LASER),
            CharGetResist(found, FD_PSYCHIC),
            CharGetResist(found, FD_ACID),
            CharGetResist(found, FD_POISON));
    SendThing(buf, thing);
    sprintf(buf, "^gMoney:^G[^c%ld^G] ", Character(found)->cMoney);
    SendThing(buf, thing);
    sprintf(buf, "^gExp:^G[^c%ld^G/^c%ld^G] ", Character(found)->cExp, PlayerExpNeeded(found));
    SendThing(buf, thing);
    SendThing("^gPos:^G[^c", thing);
    SendThing(TYPESPRINTF(buf, Character(found)->cPos, posList, 512), thing);
    SendThing("^G] ^gSex:^G[^c", thing);
    SendThing(TYPESPRINTF(buf, Character(found)->cSex, sexList, 512), thing);
    SendThing("^G]\n", thing);
    /* Hunger Thirst Intox */
    sprintf(buf, "^gBank:^G[^c%ld^G] ", Plr(found)->pBank);
    SendThing(buf, thing);
    sprintf(buf, "^gHunger:^G[^c%hd^G] ", Plr(found)->pHunger);
    SendThing(buf, thing);
    sprintf(buf, "^gThirst:^G[^c%hd^G] ", Plr(found)->pThirst);
    SendThing(buf, thing);
    sprintf(buf, "^gIntox:^G[^c%hd^G]\n", Plr(found)->pIntox);
    SendThing(buf, thing);
    break;

  default:
    break;
  }
  for (extra = found->tExtra; extra; extra=extra->eNext) {
    sprintf(buf,
            "^gExtra: ^c%-31s = ",
            StrTruncate(truncateStr,extra->eKey->sText,  30));
    SendThing(buf, thing);
    StrTruncate(truncateStr,extra->eDesc->sText, 30);
    StrOneLine(truncateStr);
    sprintf(buf, "%s\n", truncateStr);
    SendThing(buf, thing);
  }
  for (property = found->tProperty; property; property=property->pNext) {
    sprintf(buf,
            "^gProp.: ^c%-31s = ",
            StrTruncate(truncateStr,property->pKey->sText,  30));
    SendThing(buf, thing);
    StrTruncate(truncateStr,property->pDesc->sText, 30);
    StrOneLine(truncateStr);
    sprintf(buf, "%s\n", truncateStr);
    SendThing(buf, thing);
  }
  if (found->tType >= TTYPE_BASE) {
    for (link = Base(found)->bLink; link; link=link->lNext) {
      if (link->lType==BL_CONTROL) {
        sprintf(buf, 
                "^gLink: [%s] %s@%s\n",
                linkTypeList[link->lType],
                link->lDetail.lSock->sHomeThing->tSDesc->sText,
                link->lDetail.lSock->sSiteName);
      } else {
        sprintf(buf, 
                "^gLink: [%s] -> %s\n",
                linkTypeList[link->lType],
                link->lDetail.lThing->tSDesc->sText);
      }
      SendThing(buf, thing);
    }
  }

  if (readPlayer) {
    THINGFREE(found);
  }
}

CMDPROC(CmdAt) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  THING *from;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  found = ThingFind(srcKey, -1, NULL, TF_PLR_WLD|TF_OBJ_WLD|TF_MOB_WLD, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }

  from = Base(thing)->bInside;
  ThingTo(thing, Base(found)->bInside);
  ParseCommand(thing, cmd);
  ThingTo(thing, from);
}

CMDPROC(CmdForce) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  SOCK  *sockFound;
  SOCK  *sockThing;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  found = ThingFind(srcKey, -1, NULL, TF_PLR_WLD|TF_MOB_WLD, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }

  sockFound=BaseControlFind(found);
  sockThing=BaseControlFind(thing);
  if ((sockFound)&&(sockThing)&&(sockFound!=sockThing)&&
      (Character(sockFound->sHomeThing)->cLevel>=
       Character(sockThing->sHomeThing)->cLevel)) {
    /* tell the god what s/he did */
    SendAction("^wYou try to force $N to ^w'", thing, found, SEND_SRC|SEND_CAPFIRST);
    SendAction(cmd,  thing, found, SEND_SRC);
    SendAction("'^w, but they are too powerful.\n", thing, found, SEND_SRC);
    /* warn the victim */
    SendAction("^w$n tries to force you to ^w'", thing, found, SEND_DST|SEND_CAPFIRST);
    SendAction(cmd,  thing, found, SEND_DST);
    SendAction("'^w, but they fail.\n", thing, found, SEND_DST);
    return;
  } 
  /* tell the god what s/he did */
  SendAction("^rYou force $N to ^w'", thing, found, SEND_SRC|SEND_CAPFIRST);
  SendAction(cmd,  thing, found, SEND_SRC);
  SendAction("'\n", thing, found, SEND_SRC);
  /* warn the victim */
  SendAction("^r$n forces you to ^w'", thing, found, SEND_DST|SEND_CAPFIRST);
  SendAction(cmd,  thing, found, SEND_DST);
  SendAction("'\n", thing, found, SEND_DST);

  /* make the victim act */
  if (!sockFound) {
    ParseCommand(found, cmd);
  } else {
    QInsert(sockFound->sIn, "\n");
    QInsert(sockFound->sIn, cmd);
  }
}

/* Force logout a character */
CMDPROC(CmdCutConn) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  SOCK  *sockFound;
  SOCK  *sockThing;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  found = ThingFind(srcKey, -1, NULL, TF_PLR_WLD, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }

  sockFound=BaseControlFind(found);
  sockThing=BaseControlFind(thing);
  if ((sockFound)&&(sockThing)&&(sockFound!=sockThing)&&
      (Character(sockFound->sHomeThing)->cLevel>=
       Character(sockThing->sHomeThing)->cLevel)) {
    /* tell the god what s/he did */
    SendAction("^wYou try to cut $N's connection, but they are too powerful.\n", thing, found, SEND_SRC|SEND_CAPFIRST);
    /* warn the victim */
    SendAction("^w$n tried to cut your connection, but failed.\n", thing, found, SEND_DST|SEND_CAPFIRST);
    return;
  }
  if (!sockFound) {
    SendAction("^r$N doesnt seem to have a connection to cut\n", thing, found, SEND_SRC|SEND_CAPFIRST);
  } else {
    /* tell the god what s/he did */
    SendAction("^rYou cut $N's connection\n", thing, found, SEND_SRC|SEND_CAPFIRST);
    /* warn the victim */
    SendAction("^rA god cuts your connection\n", thing, found, SEND_DST|SEND_CAPFIRST);
    /* save them out */
    /* Update where they start */
    if (found->tType == TTYPE_PLR && Base(found)->bInside && Base(found)->bInside->tType==TTYPE_WLD)
      Plr(found)->pStartRoom = Wld(Base(found)->bInside)->wVirtual;
    else
      Plr(found)->pStartRoom = -1;
    PlayerWrite(found, PWRITE_PLAYER);
    sockFound->sMode = MODE_KILLSOCKET; /* they're not long for this world.... */
  }
}

/* Delete a player */
CMDPROC(CmdDelPlayer) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  THING *player;
  SOCK  *sock = NULL;
  BYTE   buf[256];
  BYTE   readPlayer = FALSE;

  cmd = StrOneWord(cmd, buf); /* lose the command at the start */
  if (STRICMP(buf, "delplayer")) {
    SendThing("^wCarefull with that! ^g(type DELPLAYER in full if you mean it)\n", thing);
    return;
  }

  player = PlayerFind(cmd);
  if (!player) {
    player = PlayerRead(cmd, PREAD_SCAN);
    if (!player) {
      SendThing("^wThey don't seem to exist, so you cant delete 'em.\n", thing);
      return;
    }
    readPlayer = TRUE;
  }

  sock = BaseControlFind(thing);
  if (Character(player)->cLevel >= Character(sock->sHomeThing)->cLevel) {
    SendThing("^wThey are too godlike for you to delete 'em.\n", thing);
    return;
  }
  
  if (readPlayer) {
    THINGFREE(player);
    /* read their objects in too so that we update # in game */
    player = PlayerRead(cmd, PREAD_NORMAL);
  }

  /* tell the god what s/he did */
  SendAction("^rYou ^wDELETE ^r$N\n", thing, player, SEND_SRC|SEND_CAPFIRST);
  /* tell others */
  SendAction("^r$n ^wDELETES ^r$N - they're gone....\n", thing, player, SEND_ROOM|SEND_CAPFIRST);
  /* tell victim */
  SendAction("^r$n ^wDELETES ^ryou - you're outta here buddy\n", thing, player, SEND_DST|SEND_CAPFIRST);

  /* get rid of the playerFile - but keep a backup in case we change our mind */
  PlayerDelete(player);
}


/* Undelete a player, if the .plr.del file exists */
CMDPROC(CmdUnDelPlayer) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   bufPlrDel[256];
  BYTE   bufCrash[256];
  BYTE   bufPlr[256];
  BYTE   bufCmd[256];
  BYTE   buf[256];
  BYTE   playerName[256];
  FILE  *filePlr;
  FILE  *fileCrash;

  cmd = StrOneWord(cmd, buf); /* lose the command at the start */
  if (STRICMP(buf, "undelplayer")) {
    SendThing("^wCarefull with that! ^g(type UNDELPLAYER in full if you mean it)\n", thing);
    return;
  }
  cmd=StrOneWord(cmd,playerName);
  StrToLower(playerName);
  if (!playerName[0]) {
    SendThing("^wCarefull with that! ^g(type UNDELPLAYER <player name> )\n", thing);
    return;
  }
#ifdef WIN32
  sprintf(bufCrash,"crash\\%s.plr",playerName);
  sprintf(bufPlr,"player\\%s.plr",playerName);
  sprintf(bufPlrDel,"player\\%s.plr.del",playerName);
  sprintf(bufCmd,"move %s %s",bufPlrDel,bufPlr);
#else
  sprintf(bufCrash,"crash/%s.plr",playerName);
  sprintf(bufPlr,"player/%s.plr",playerName);
  sprintf(bufPlrDel,"player/%s.plr.del",playerName);
  sprintf(bufCmd,"mv %s %s",bufPlrDel,bufPlr);
#endif
  /* check first if a player file exists */
  fileCrash=fopen(bufCrash,"rb");
  filePlr=fopen(bufPlr,"rb");
  if (filePlr||fileCrash) {
    if (fileCrash)
      fclose(fileCrash);
    if (filePlr)
      fclose(filePlr);
    /* tell the god what s/he did */
    sprintf(buf,"^rYou ^wUNDELETE ^r%s but the player is not deleted!!",
      playerName);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_CAPFIRST);
    /* tell others */
    sprintf(buf,"^r$n ^wUNDELETES ^r%s - but they are not deleted!",
      playerName);
    SendAction(buf, thing, NULL, SEND_ROOM|SEND_CAPFIRST);
    return;
  }
  sprintf(buf,"^rYou ^wUNDELETE ^r%s.",
    playerName);
  SendAction(buf, thing, NULL, SEND_SRC|SEND_CAPFIRST);
  /* tell others */
  sprintf(buf,"^r$n ^wUNDELETES ^r%s.",
    playerName);
  SendAction(buf, thing, NULL, SEND_ROOM|SEND_CAPFIRST);
  system(bufCmd);
  return;
}

/* Watch what somebody is up to */
CMDPROC(CmdSnoop) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE      srcKey[256];
  LWORD     srcNum;
  LWORD     srcOffset;
  THING    *found;
  BASELINK *baseLink;
  SOCK     *sockFound;
  SOCK     *sockThing;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  found = ThingFind(srcKey, -1, NULL, TF_PLR_WLD|TF_MOB, &srcOffset);
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }

  if (found == thing) {
    /* stop all snoops */
    SendAction("^rYou just snoop yourself\n", thing, found, SEND_SRC|SEND_CAPFIRST);
    baseLink = BaseLinkFind(Base(thing)->bLink, BL_TELEPATHY_RCV, NULL);
    while (baseLink) {
      SendAction("^rYou stop spying on $N\n", thing, baseLink->lDetail.lThing, SEND_SRC|SEND_CAPFIRST);
      BaseLinkFree(thing, baseLink);
      baseLink = BaseLinkFind(Base(thing)->bLink, BL_TELEPATHY_RCV, NULL);
    }
    return;
  }

  sockFound=BaseControlFind(found);
  sockThing=BaseControlFind(thing);
  if ((!sockFound)&&(sockThing)&&(found->tType==TTYPE_PLR)&&
      (Character(found)->cLevel>=Character(sockThing->sHomeThing)->cLevel)) {
    SendAction("^wYou try to spy on $N, but they are too powerfull.\n", thing, found, SEND_SRC|SEND_CAPFIRST);
    return;
  }
  if ((sockFound)&&(sockThing)&&(sockFound!=sockThing)&&
      (Character(sockFound->sHomeThing)->cLevel>=
       Character(sockThing->sHomeThing)->cLevel)) {
    SendAction("^wYou try to spy on $N, but they are too powerfull.\n", thing, found, SEND_SRC|SEND_CAPFIRST);
    return;
  }
  /* Check for an allready existing link, if found remove it */
  baseLink = BaseLinkFind(Base(thing)->bLink, BL_TELEPATHY_RCV, found);
  if (baseLink) {
    SendAction("^rYou stop spying on $N\n", thing, found, SEND_SRC|SEND_CAPFIRST);
    BaseLinkFree(thing, baseLink);
  } else {
    /* Otherwise, make a new link */
    SendAction("^rYou start spying on $N\n", thing, found, SEND_SRC|SEND_CAPFIRST);
    BaseLinkCreate(found, thing, BL_TELEPATHY_SND);
  }
}

CMDPROC(CmdSite) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  SITE *site;
  SOCK *sock;
  BYTE  buf[256];
  BYTE  siteTime[256];
  LWORD i;

  sock = BaseControlFind(thing);
  if (!sock) return;
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (!*cmd) {
    sprintf(buf, "^w%-25s ^p%-7s ^P%-25s ^b%s\n",
      "Site",
      "Status",
      "Modified on Date",
      "By Player"
    );
    SendThing(buf, thing);
    sprintf(buf, "^V%-25s ^P%-7s ^R%-25s ^B%s\n",
      "====",
      "======",
      "================",
      "========="
    );
    SendThing(buf, thing);
    for(i=0; i<siteIndex.iNum; i++) {
      site = Site(siteIndex.iThing[i]);
      strcpy(siteTime, ctime(&site->sDate));
      siteTime[strlen(siteTime)-1] = '\0';
      sprintf(buf, "^w%-25s ^p%-7s ^P%-25s ^b%s\n",
        site->sSite,
        sTypeList[site->sType],
        siteTime,
        site->sPlayer->sText
      );
      SendThing(buf, thing);
    }
    SendThing("\n", thing);
    sprintf(buf, "^gTotal Number of Special Sites: ^G[^c%ld^G]\n", siteIndex.iNum);
    SendThing(buf, thing);
    return;
  }

  cmd = StrOneWord(cmd, buf); /* lose the command at the start */
  i = TYPEFIND(cmd, sTypeList);
  if (!*cmd || i == -1) {
    SendThing("Never heard of that status type, try:\n", thing);
    SENDARRAY(sTypeList, 4, thing);
    SendThing("Hint: a status of OFFSITE will delete the entry\n", thing);
    return;
  }

  site = SiteFindExact(buf);
  if (site) { 
    if (StrExact(site->sPlayer->sText, "<SYSTEM>")) {
      SendThing("That is a system defined entry it cannot be changed online\n", thing);
      return;
    }
    if (i == SITE_OFFSITE) {
      sprintf(buf, "^wRemoving Site ^G[^g%s^G]^w", site->sSite);
      SendThing(buf, thing);
      SITEFREE(site);
      SiteWrite();
    } else {
      site->sType = i;
      site->sDate = time(0);
      STRFREE(site->sPlayer);
      site->sPlayer = StrAlloc(sock->sHomeThing->tSDesc);
      sprintf(buf, "^wChanging Site ^G[^g%s^G]^w to ^G[^g%s^G]\n", site->sSite, sTypeList[site->sType]);
      SendThing(buf, thing);
      SiteWrite();
    }
    return;
  }

  if (i == SITE_OFFSITE) {
    SendThing("A Site is OFFSITE by default, so no need to add it...\n", thing);
    return;
  }
  
  site = SiteCreate(sock->sHomeThing, buf, i);
  sprintf(buf, "^wAdding Site ^G[^g%s^G]^w as ^G[^g%s^G]\n", site->sSite, sTypeList[site->sType]);
  SendThing(buf, thing);
  SiteWrite();
}

CMDPROC(CmdSystem) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE  buf[256];
  LWORD objNum = 0;
  LWORD mobNum = 0;
  LWORD wldNum = 0;
  LWORD i;

  for (i=0;i<areaListMax;i++) {
    objNum += areaList[i].aObjIndex.iNum;
    mobNum += areaList[i].aMobIndex.iNum;
    wldNum += areaList[i].aWldIndex.iNum;
  }

  SendThing("^pSystem Stats:\n", thing);
  SendThing("^P-=-=-=-=-=-=\n", thing);
  sprintf(buf, "^bWld structs Loaded:   ^p%ld (%ldK)\n", wldNum, wldNum*sizeof(WLD)/1024);
  SendThing(buf, thing);
  sprintf(buf, "^bMobTemplates Loaded:  ^p%ld (%ldK)\n", mobNum, mobNum*sizeof(MOBTEMPLATE)/1024);
  SendThing(buf, thing);
  sprintf(buf, "^bMobiles Loaded:       ^p%ld (%ldK)\n", mobileIndex.iNum, mobileIndex.iNum*sizeof(MOB)/1024);
  SendThing(buf, thing);
  sprintf(buf, "^bObjTemplates Loaded:  ^p%ld (%ldK)\n", objNum, objNum*sizeof(OBJTEMPLATE)/1024);
  SendThing(buf, thing);
  sprintf(buf, "^bObjects Loaded:       ^p%ld (%ldK)\n", objectIndex.iNum, objectIndex.iNum*sizeof(OBJ)/1024);
  SendThing(buf, thing);
  sprintf(buf, "^bPlayers Loaded:       ^p%ld (%ldK)\n", playerIndex.iNum, playerIndex.iNum*sizeof(PLR)/1024);
  SendThing(buf, thing);
  sprintf(buf, "^bHelp Entries Loaded:  ^p%ld (%ldK)\n", helpIndex.iNum, helpIndex.iNum*sizeof(HELP)/1024);
  SendThing(buf, thing);
  sprintf(buf, "^bExit structs Loaded:  ^p%ld (%ldK)\n", exitNum, exitNum*sizeof(EXIT)/1024);
  SendThing(buf, thing);
  sprintf(buf, "^b# Fighting:           ^p%ld\n", fightIndex.iNum);
  SendThing(buf, thing);
  sprintf(buf, "^bStr MemUsage:         ^p%ldK\n", strMemTotal/1024);
  SendThing(buf, thing);
  sprintf(buf, "^bMalloc MemUsage:      ^p%ldK\n", memUsed/1024);
  SendThing(buf, thing);

/* Should use getrusage here to find out memory consumption */
}

CMDPROC(CmdUsers) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE buf[256];
  BYTE buf2[256];
  BYTE bufSite[256];
  SOCK *sock;
  SOCK *sockFind;

  if (Character(thing)->cLevel<LEVEL_ADMIN) {
    sprintf(buf, 
            "^p%-25s %-4s  %s\n",
            "User Name",
            "Idle",
            "Logged in with");
    SendThing(buf, thing);
    sprintf(buf, 
            "^P%-25s %-4s  %s\n",
            "-=-=-=-=-",
            "-=-=",
            "-=-=-=-=-=-=-=");
    SendThing(buf, thing);
  } else {
    sprintf(buf, 
            "^p%-25s %-4s  %-16s %s\n",
            "User Name",
            "Idle",
            "IP Address",
            "Site");
    SendThing(buf, thing);
    sprintf(buf, 
            "^P%-25s %-4s  %-16s %s\n",
            "-=-=-=-=-",
            "-=-=",
            "-=-=-=-=-=",
            "-=-=");
    SendThing(buf, thing);
  }


  for (sock = sockList; sock; sock=sock->sNext) {
    if (sock->sHomeThing) {
      if ( BIT(Plr(sock->sHomeThing)->pSystem,PS_GODINVIS) &&
           (Character(thing)->cLevel<LEVEL_ADMIN) ) 
        continue;
      sprintf(buf2,
              "%s (%hd %c%c%c%c)",
              sock->sHomeThing->tSDesc->sText,
              Character(sock->sHomeThing)->cLevel,
              raceList[Plr(sock->sHomeThing)->pRace].rName[0],
              raceList[Plr(sock->sHomeThing)->pRace].rName[1],
              classList[Plr(sock->sHomeThing)->pClass].cName[0],
              classList[Plr(sock->sHomeThing)->pClass].cName[1]);
      if (Character(thing)->cLevel<LEVEL_ADMIN) {
        /* first, let's find the site alias we should
         * have for this character. This is just the name
         * of the first character who's logged in from this
         * site. */
        strcpy(bufSite,sock->sHomeThing->tSDesc->sText);
        for (sockFind=sockList; sockFind!=sock; sockFind=sockFind->sNext) {
          if (!strcmp(sock->sSiteIP,sockFind->sSiteIP)) {
            strcpy(bufSite,sockFind->sHomeThing->tSDesc->sText);
            break;
          }
        }
        if (sock->sMode != MODE_PLAY) {
          sprintf(buf, 
                  "^g%-25s ^b%4ld  %s <%s>\n",
                  buf2,
                  Plr(sock->sHomeThing)->pIdleTick,
                  bufSite,
                  sModeList[sock->sMode]);
        } else {
          sprintf(buf, 
                  "^g%-25s ^b%4ld  %s\n",
                  buf2,
                  Plr(sock->sHomeThing)->pIdleTick,
                  bufSite);
        }
      } else { /* show them everything */
        if (sock->sMode != MODE_PLAY) {
          sprintf(buf, 
                  "^g%-25s ^b%4ld  %-16s %s <%s>\n",
                  buf2,
                  Plr(sock->sHomeThing)->pIdleTick,
                  sock->sSiteIP,
                  sock->sSiteName,
                  sModeList[sock->sMode]);
        } else {
          sprintf(buf, 
                  "^g%-25s ^b%4ld  %-16s %s\n",
                  buf2,
                  Plr(sock->sHomeThing)->pIdleTick,
                  sock->sSiteIP,
                  sock->sSiteName);
        }
      }
    } else {
      sprintf(buf, 
              "^g%-25s ^b%4d  %-16s %s\n",
              "<???>",
              0,
              sock->sSiteIP,
              sock->sSiteName);
    }
    SendThing(buf, thing);
  }
}

CMDPROC(CmdSwitch) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE         srcKey[256];
  LWORD        srcNum;
  LWORD        srcOffset;
  THING       *found;
  SOCK        *sock;

  sock = BaseControlFind(thing);
  if (!sock) return;
  
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (*cmd) {
    cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);
    found = ThingFind(srcKey, -1, NULL, TF_MOB_ANYWHERE, &srcOffset);
    if (!found) {
      SendThing("^bThere doesnt appear to be anything like that around\n", thing);
      return;
    }
  } else {
    /* switch back home */
    if (sock->sHomeThing != sock->sControlThing) {
      if (BaseControlFind(sock->sHomeThing)) {
        SendThing("^wYour body is allready occupied\n", thing);
        return;
      }  
      SendThing("^yYou return to yourself\n", thing);
      BaseControlFree(thing, sock); /* turf old control link */
      BaseControlAlloc(sock->sHomeThing, sock); /* control homething */
      return;
    } else {
      SendThing("^wSwitch fine, but switch control to WHOM?!?\n", thing);
      return;
    }
  }

  /* Move on to new body */
  if (BaseControlFind(found)) {
    SendThing("^wThat body is allready occupied\n", thing);
    return;
  }  
  SendThing("^yYou take control of a new body\n", thing);
  BaseControlFree(thing, sock); /* turf old control link */
  BaseControlAlloc(found, sock); /* control homething */
}

CMDPROC(CmdResetSkill) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  THING *search;
  LWORD  readPlayer = FALSE;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  search = Base(thing)->bInside;
  found = ThingFind(srcKey, -1, search, TF_PLR_WLD|TF_PLR, &srcOffset);
  if (!found) {
    found = PlayerRead(srcKey, PREAD_NORMAL);
    readPlayer = TRUE;
  }
  if (!found) {
    SendThing("^bThere doesnt appear to be anyone like that around\n", thing);
    return;
  }

  /* tell the god what s/he did */
  SendAction("^rYou ^wResetskill ^r$N\n", thing, found, SEND_SRC|SEND_CAPFIRST);
  SendAction("^r$n ^wResetskill's ^ryou\n", thing, found, SEND_DST|SEND_CAPFIRST);

  PlayerResetSkill(found);

  if (readPlayer) {
    PlayerWrite(found, PWRITE_PLAYER);
    THINGFREE(found);
  }
}

CMDPROC(CmdShutdown) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  if (STRICMP(cmd, "shutdown")) {
    SendThing("^wAgh no dont even think about it (type SHUTDOWN if you mean it)\n", thing);
    return;
  }

  SendThing("^wYou meanie, now you've done it...\n", thing);
  crimsonRun = FALSE;
  unlink(REBOOT_FLAG_FILE); /* dont autoreboot */
}

/* NOTE: This function works in conjunction with the reboot code
 * in socket.c. Look near the very end of it for all the stuff
 * that uses the variables sockRebootTime, sockRebootTimeMsg, sockRebootCause.
 * There is a big description of how rebooting works with the code
 * in there. This proc just sets the variables/files and reports 
 * status. Well, ok, this proc also spawns off a recompile fork. */
CMDPROC(CmdReboot) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE           buf[256];
  WORD           help;
  LWORD          rebootMin;
  LWORD          i;
  FILE          *rebootFile;
  LWORD          fRC; /* fork Return Code */
  BYTE           rebootFileExists;
  LWORD          delay;
  SOCK*          sock;

  sock = BaseControlFind( thing );

  /* either PS_CODER or LEVEL_SECURITY required 
     already have to be at least level 245 to get this far
     check for security and if not that high check for special case bit CODER
     if not then exit with message
  */
  if( !ParseCommandCheck(PARSE_COMMAND_SECURITY, sock, "" )) {
    if( !BIT(Plr(thing)->pSystem,PS_CODER ) ) {
      /* if not LEVEL_SECURITY must have bit PS_CODER */
      SendAction("^cI'm afraid you're not authorized to do that\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
      return;
    }
  }

  cmd = StrOneWord(cmd, buf); /* lose the command at the start */

  if (STRICMP(buf, "reboot")) {
    SendThing("^wAgh no dont even think about it (type REBOOT if you mean it)\n", thing);
    return;
  }

  if ((rebootFile=fopen(REBOOT_SIGNAL_FILE,"rb"))!=NULL) {
    rebootFileExists=1;
    fclose(rebootFile);
    delay=INILWordRead(REBOOT_SIGNAL_FILE,"delay",-1);
  } else {
    rebootFileExists=0;
    delay=0;
  }
  
  help=0;

  cmd = StrOneWord(cmd, buf); /* lose the command at the start */
  /* if no command line, print help */
  if (!buf[0]) {
    help=1;
  } else if (!STRICMP("compile",buf)) {
#ifdef WIN32
          fRC; /* disable the stupid message about local variable not used */
          SendThing("^wSorry, REBOOT COMPILE is unavailable in Win32 environments. \n", thing);
          SendThing("^wIf you want to do this under Win32, you're going to have to code\n", thing);
          SendThing("^wthis functionality yourself.\n", thing);
          unlink(REBOOT_SIGNAL_FILE);
          return;
#endif
    /* instigate a server recompiling */
    /* first, cancel any pending reboot */
    sockRebootTime=0;
    sockRebootTimeMsg=REBOOT_NEVER;
    if ((rebootFileExists)&&(delay==-1)) {
      /* error! We're already compiling-in-progress */
      SendThing("^wYou cannot REBOOT COMPILE because the server\nalready has a recompile in progress...\n", thing);
    } else {
      /* instigate a new recompile! */
      if ((rebootFile=fopen(REBOOT_SIGNAL_FILE,"wb"))==NULL) {
        SendThing("^wError! Cannot write to reboot signal file! Contact the SysAdmin!\n", thing);
        Log(LOG_ERROR, "Cannot write reboot signal file!!\n");
      } else {
        fprintf(rebootFile,"delay = -1\n");
        fclose(rebootFile);
        rebootFileExists=1;
        delay=-1;
        /* now fork off a recompile task */
        INIRead("crimson2.ini","RecompScript","",buf);
        if (buf[0]) {
#ifdef WIN32
          fRC; /* disable the stupid message about local variable not used */
          SendThing("^wSorry, REBOOT COMPILE is unavailable in Win32 environments. \n", thing);
          SendThing("^wIf you want to do this under Win32, you're going to have to code\n", thing);
          SendThing("^wthis functionality yourself.\n", thing);
          unlink(REBOOT_SIGNAL_FILE);
          return;
#else
          fRC=fork();
          if (fRC==-1) {
            /* couldn't fork?! */
            SendThing("^wError! Could not fork off recompile process!?\n", thing);
            unlink(REBOOT_SIGNAL_FILE);
          } else if (fRC==0) {
            /* child process */
            /* Note: This execve should, if successfull, never return. If
            * the execve works, this thread will be completely replaced
            * by the program we are calling. In other words, we'll stop
            * being a MUD server, which is what we want anyways.  */
            execlp(buf,buf,NULL);
            /* if we have passed through the execve and are now here, then 
            * we have fucked up someplace because the execve has failed. */
            /* let's just exit RIGHT NOW! */
            unlink(REBOOT_SIGNAL_FILE);
            exit(1);
          } else {
            /* parent process... just keep going */
            sprintf(sockRebootCause,"REASON: Server recompile & reboot requested by %s.\n",thing->tSDesc->sText);
          }
#endif
        } else {
          SendThing("^wThis operation has been disabled. Contact the SysAdmin!\n", thing);
          return; /* was still setting it even though its disabled
                  also still says reboot compile even if specified reboot never
                  or is this only on win32 ?
          */
        }
      }
    }
  } else if (!STRICMP("never",buf)) {
    sockRebootTime=0;
    sockRebootTimeMsg=REBOOT_NEVER;
    sockRebootCause[0]=0;
    sockRebootPlayer[0]=0;
  } else if (!STRICMP("empty",buf)) {
    sockRebootTime=0;
    sockRebootTimeMsg=REBOOT_WHENEMPTY;
    sprintf(sockRebootCause,"REASON: Reboot requested by %s.\n",thing->tSDesc->sText);
    strcpy(sockRebootPlayer,thing->tSDesc->sText);
  } else if (!STRICMP("now",buf)) {
    SendThing("^wYou meanie, now you've done it...\n", thing);
    crimsonRun = FALSE;
    sprintf(sockRebootCause,"REASON: Reboot requested by %s.\n",thing->tSDesc->sText);
    strcpy(sockRebootPlayer,thing->tSDesc->sText);
    /* we don't have to do this, but what the hell... */
    sockRebootTime=0;
    sockRebootTimeMsg=REBOOT_NEVER;
  } else {
    /* try to parse it as a number */
    sscanf(buf,"%li",&rebootMin);
    if (rebootMin>0) {
      sockRebootTime=time(NULL)+rebootMin*60;
      /* VERY IMPORTANT! The following will cause a reboot system announcement
       * to be sent immediately, and then a periodic announcement will be
       * generated automatically, counting down to time 0. The timing and format
       * of these system messages are defined in socket.c */
      sockRebootTimeMsg=0;
      sprintf(sockRebootCause,"REASON: Reboot requested by %s.\n",thing->tSDesc->sText);
      strcpy(sockRebootPlayer,thing->tSDesc->sText);
    } else {  /* can't parse anything */
      help=1;
    }
  }

  if (sockRebootTime) {
    i=sockRebootTime-time(NULL);
    sprintf(buf,"^rSERVER IS SET TO REBOOT IN ^w%li min %li seconds\n",i/60,i%60);
  } else {
    if (sockRebootTimeMsg== REBOOT_WHENEMPTY) {
      sprintf(buf,"^rSERVER IS SET TO REBOOT ^wWHEN EMPTY\n");
    } else if (rebootFileExists) {
      if (delay==-2) {
        sprintf(buf,"^rSERVER IS SET TO REBOOT ^wNEVER: Compile error during previous recompile request.\n");
      } else {
        sprintf(buf,"^rSERVER IS SET TO REBOOT ^wPENDING AUTOMATIC RECOMPILE (in progress)\n");
      }
    } else {
      sprintf(buf,"^rSERVER IS SET TO REBOOT ^wNEVER\n");
      /* just in case... This could be left over from a recompile
       * which did not actually cause a reboot.  */
      sockRebootCause[0]=0;
      sockRebootPlayer[0]=0;
    }
  }
  SendThing(buf, thing);
  if (sockRebootCause[0])
    SendThing(sockRebootCause, thing);

  if (help) {
    SendThing("\n^cREBOOT         ^b- Query reboot status and print this help\n", thing);
    SendThing("^cREBOOT now     ^b- reboot server immediately\n", thing);
    SendThing("^cREBOOT empty   ^b- reboot server when it's empty (no players logged on)\n", thing);
    SendThing("^cREBOOT never   ^b- cancel any pending reboot\n", thing);
    SendThing("^cREBOOT <min>   ^b- set server to reboot in <min> minutes\n", thing);
    SendThing("^cREBOOT compile ^b- automatically fork a process to update and recompile the\n", thing);
    SendThing("^c               ^b  server. Reboot will be auto-initiated if required.\n", thing);
    SendThing("^rThis command requires EXACT syntax so that you don't do something by mistake.\n",thing);
    return;
  }
}

CMDPROC(CmdPlayerList) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  DIRLIST        playerDir;
  BYTE           buf[256];
  WORD           startLevel;
  WORD           endLevel;
  WORD           count[LEVEL_CODER+1];
  WORD           i;
  WORD           j;
  WORD           ind;
  WORD           column;
  WORD           row;
  WORD           printSummary;
  BYTE           playerName[256];
  BYTE           playerFileName[256];
  FILE          *playerFile;
  LWORD          sLen;
  WORD           mortalTotal;
  WORD           immortalTotal;

  /* ok, so this command will list players / stats according to
   * some parameters. If you don't pass this function any params,
   * it will print out a summary. If you pass it 1 or 2 numeric params,
   * will will print out player names within that level range. First
   * param is minimum level. Second is max level. Default to
   * LEVEL_NEWBIE and LEVEL_CODER by default. */

  startLevel=LEVEL_NEWBIE;
  endLevel=LEVEL_CODER;
  for (i=0;i<LEVEL_CODER+1;i++)
    count[i]=0;
  mortalTotal=0;
  immortalTotal=0;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */

  /* if no command line, print help */
  if (!(*cmd)) { 
    SendThing("^pUsage:\n^P=-=-=-=\n", thing);
    SendThing("^cPLAYERLIST <command> [<min level>] [<max level>] \n", thing);
    SendThing("^cPLAYERLIST <min level> [<max level>]\n", thing);
    SendThing("\n^c<command>   ^bcan be '^gstat^b' (show # players at each level) or\n",thing);
    SendThing("            ^b'^glist^b' (show player names and levels).\n", thing);
    SendThing("^c<min level> ^bstarting player level to display. Default is 1.\n",thing);
    SendThing("^c<max level> ^bending player level to display. Default is max level.\n",thing);
    SendThing("\n^bIf you don't give a ^c<command>^b then it will default to ^gstat^b.\n",thing);
    SendThing("\n^yWARNING: ^bThis command is a serious CPU pig, so please use it sparingly.\n",thing);
    return;
  }

  /* set default - currently to show statistics */
  printSummary=1;

  /* check for command */
  cmd=StrOneWord(cmd,buf);
  if (StrAbbrev("listing",buf)) {
    printSummary=0;
    if (*cmd)
      cmd=StrOneWord(cmd,buf);
    else
      buf[0]=0;
  } else if (StrAbbrev("statistics",buf)) {
    printSummary=1;
    if (*cmd)
      cmd=StrOneWord(cmd,buf);
    else
      buf[0]=0;
  } /* else assume this is a numeric argument, and go with default */

  /* check for level specifications */
  if (buf[0])
    startLevel=atol(buf);
  if (startLevel<LEVEL_NEWBIE) 
    startLevel=LEVEL_NEWBIE;
  if (startLevel>LEVEL_CODER)
    startLevel=LEVEL_CODER;
  if (*cmd) {
    cmd = StrOneWord(cmd, buf); /* ending level */
    endLevel=atol(buf);
    if (endLevel<LEVEL_NEWBIE) 
      endLevel=LEVEL_NEWBIE;
    if (endLevel>LEVEL_CODER)
      endLevel=LEVEL_CODER;
  }
  if (startLevel>endLevel) {
    /* just swap'em */
    i=startLevel;
    startLevel=endLevel;
    endLevel=i;
  }

  /* ok, let's do it! */
  column=3;
  if (!printSummary) {
    for(i=0;i<column;i++)
      SendThing(" ^pLevel          Name   ",thing);
    SendThing("\n",thing);
    for(i=0;i<column;i++)
      SendThing(" ^p=-=-=  =-=-=-=-=-=-   ",thing);
    SendThing("\n",thing);
  }

  /* first, let's list the players that we've got loaded. */
  ind=0;
  for (i=0;i<playerIndex.iNum;i++) {
    /* add to our stats */
    count[Character(playerIndex.iThing[i])->cLevel]++;
    if ((Character(playerIndex.iThing[i])->cLevel>=startLevel) &&
        (Character(playerIndex.iThing[i])->cLevel<=endLevel)) {
      if (Character(playerIndex.iThing[i])->cLevel>=LEVEL_IMMORTAL)
        immortalTotal++;
      else
        mortalTotal++;
      /* check for listing */
      if (!printSummary) {
        sprintf(buf,"^r % 4i ^g%14s   ",
          Character(playerIndex.iThing[i])->cLevel,
          Thing(playerIndex.iThing[i])->tSDesc->sText);
        SendThing(buf,thing);
        ind++;
        if (ind==column) {
          SendThing("\n",thing);
          ind=0;
        }
      }
    }
  }

  /* now let's scan the player directory for off-line players */
  if (! DirlistOpen(&playerDir, "player", "*.plr") ) {
    Log(LOG_ERROR, "Directory player/ doesnt exist... create it!\n");
    exit(ERROR_BADFILE);
  }
  while( DirlistGetNext(&playerDir, playerName) ) {
    sLen=strlen(playerName);
    strcpy(playerFileName,playerName);
    sprintf(buf,"player/%s",playerFileName);
    if ((sLen>4)&&(!strcmp(playerName+sLen-4,".plr"))) {
      playerName[sLen-4]=0;
      /* Perhaps the best idea here would be to 
       * do the following: 
       *  player=PlayerRead(playerName,PREAD_SCAN);
       * However, having tried this, it's obvious this
       * solutions is **WAY** too slow. So we have
       * to go behind the scenes a little. */
      playerFile=fopen(buf,"r");
      if (playerFile>0) {
        if (PlayerReadHeader(playerFile,"Level:")) {
          i=FileByteRead(playerFile);
          count[i]++;
          if ((i>=startLevel) &&
                (i<=endLevel)) {
            if (i>=LEVEL_IMMORTAL)
              immortalTotal++;
            else
              mortalTotal++;
            if (!printSummary) {
              sprintf(buf,"^r % 4i ^g%14s   ",i,playerName);
              SendThing(buf,thing);
              ind++;
              if (ind==column) {
                SendThing("\n",thing);
                ind=0;
              }
            }
          }
        }
        fclose(playerFile);
      } else {
        printf("Can't open %s\n",buf);
      }
    }
  }
  DirlistClose(&playerDir);
  if (!printSummary)
    SendThing("\n",thing);

  /* ok, we're done going through our players. Phew. */
  /* one last thing - if we're printing a summary, print it now. */
  if (printSummary) {
    column=5;
    row=(endLevel-startLevel+1)/column;
    /* add another line if we need a partial line */
    if ((endLevel-startLevel+1)%column) {
      row++;
    }
    /* now print out our funky stats */
    for (j=0;j<column;j++) {
      SendThing("^p  Lvl  # Plrs   ",thing);
    }
    SendThing("\n",thing);
    for (j=0;j<column;j++) {
      SendThing("^p  =-=  =-=-=-   ",thing);
    }
    SendThing("\n",thing);
    for (i=0;i<row;i++) {
      for (j=0;j<column;j++) {
        ind=startLevel+i+(j*row);
        if (ind<=endLevel) {
          sprintf(buf," ^r% 4i  ^g% 6i   ",ind,count[ind]);
          SendThing(buf,thing);
        }
      }
      SendThing("\n",thing);
    }
  }
  sprintf(buf,"^g%i ^bmortals and ^g%i ^bimmortals shown.\n",mortalTotal,immortalTotal);
  SendThing(buf,thing);
  /* that's it. We're done. */
}

CMDPROC(CmdLog) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  BYTE   dstKey[256];
  LWORD  dstNum;
  THING *found;
  LWORD  readPlayer = FALSE;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, dstKey, &dstNum);

  found = ThingFind(srcKey, -1, NULL, TF_PLR_WLD, &srcOffset);
  if (!found) {
    found = PlayerRead(srcKey, PREAD_NORMAL);
    readPlayer = TRUE;
  }
  if (!found) {
    SendThing("^bThere doesnt appear to be anything like that around\n", thing);
    return;
  }
  if (found->tType!=TTYPE_PLR) {
    SendThing("^bAttempt to log mob/obj/wld! You can only log players.\n", thing);
    goto exit;
  }
  SendThing("^gPlayer ^c",thing);
  SendThing(found->tSDesc->sText,thing);
  if (dstKey[0]&& (StrAbbrev(dstKey,"start")||StrAbbrev(dstKey,"on")) ) {
    if (BIT(Plr(found)->pSystem,PS_LOG)) {
      SendThing(" ^gis already being logged.\n",thing);
    } else {
      BITSET(Plr(found)->pSystem,PS_LOG);
      SendThing(" ^gis now being logged.\n",thing);
    }
    return;
  } else if (dstKey[0]&& (StrAbbrev(dstKey,"stop")||StrAbbrev(dstKey,"off")) ) {
    if (BIT(Plr(found)->pSystem,PS_LOG)) {
      SendThing(" ^gis no longer being logged.\n",thing);
      BITCLR(Plr(found)->pSystem,PS_LOG);
    } else {
      SendThing(" ^gis not being logged.\n",thing);
    }
    return;
  } 
  if (BIT(Plr(found)->pSystem,PS_LOG)) {
    SendThing(" ^gis currently being logged.\n",thing);
  } else {
    SendThing(" ^gis currently ^cNOT ^gbeing logged.\n",thing);
  }

  exit: if (readPlayer) {
    PlayerWrite(found, PWRITE_PLAYER);
    THINGFREE(found);
  }
  return;
}


