/* Crimson2 Mud Server
 * All source written/copyright Ryan Haksi 1995 *
 * This source code is proprietary. Use in whole or in part without
 * explicit permission by the author is strictly prohibited
 *
 * Current email address(es): cryogen@infoserve.net
 * Phone number: (604) 591-5295
 *
 * C4 Script Language written/copyright Cam Lesiuk 1995
 * Email: clesiuk@engr.uvic.ca
 */

/* Inventory related commands */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>

#include "crimson2.h"
#include "macro.h"
#include "queue.h"
#include "log.h"
#include "str.h"
#include "ini.h"
#include "extra.h"
#include "file.h"
#include "thing.h"
#include "index.h"
#include "edit.h"
#include "history.h"
#include "socket.h"
#include "alias.h"
#include "area.h"
#include "exit.h"
#include "world.h"
#include "send.h"
#include "base.h"
#include "object.h"
#include "char.h"
#include "mobile.h"
#include "fight.h"
#include "affect.h"
#include "effect.h"
#include "player.h"
#include "skill.h"
#include "parse.h"
#include "cmd_god.h"
#include "cmd_misc.h"
#include "group.h"
#include "sound.h"

LWORD miscWhoAllowLevelDisplay = 0;
/*
whoAllowLevelDisplay  = 1; display levels as part of the list ( not sorted )
*/
LWORD miscWhoLimitLevelDisplay = 0; /* didnt implement this one ? */
/*                         
whoLimitLevelDisplay  = 0; limit to gods ? useless if you enable wAllowByLevel
*/
LWORD miscWhoAllowByLevel = 0;
/*
whoAllowByLevel       = 1; if enabled allow who 1 10 to only see level 1 - 10 chars
                         ; or who 10 to see level 10 and up
*/
LWORD miscWhoAllowName = 0;
/*
whoAllowName          = 1; allow who name so only names show and not titles
                         ; keyword name
*/
LWORD miscWhoMortsSeeSomeone = 0;
/*
whoMortalsSeeSomeone  = 1; mortals will see someone if the person is invisible
*/
LWORD miscWhoLimitSomeone = 0;
/*
whoLimitSomeoneToGods = 0; only invisibile gods show as someone
*/
LWORD miscWhoImmsSeeSomeone = 0;
/*
whoImmsSeeGodInvis    = 1; if enabled gods must be of >= level to see godinvis gods
                       ; otherwise they see someone <godinvis>
*/

COLORPREFLIST colorPrefList[] = {

/*   name             symb   col#  order in prefs, may be different from this order*/

  { "Name:",           '0',   0 ,   0 },
  { "Description:",    '1',   0 ,   1 },
  { "LDesc:",          '2',   0 ,   2 },
  { "Info-text:",      '3',   0 ,   3 },
  { "Info-filler:",    '4',   0 ,   4 },
  { "Info-highlight:", '5',   0 ,   5 },
  { "Hint-Text:",      ';',   0 ,  11 },
  { "Hint-Highlight:", '<',   0 ,  12 },  
  { "Fight-Hit:",      '7',   0 ,   7 },
  { "Fight-Damage:",   '8',   0 ,   8 },
  { "Fight-Others:",   '9',   0 ,   9 },



  { "Speech:",         '6',   1 ,   6 },
  { "Tell:",           '@',   1 ,  16 },
  { "GTell:",          '~',   1 ,  17 },
  { "Emote:",          '`',   1 ,  18 },
  { "Gossip:",         ':',   1 ,  10 },  
  { "Auction:",        '=',   1 ,  13 },
  { "SystemAnnounce:", '>',   1 ,  14 },
  { "Godtalk:",        '?',   1 ,  15 },
   
  { "",                '`',   0 ,  18 },
  { "",                '!',   0 ,  19 },
  { "",                '#',   0 ,  20 },
  { "",                '%',   0 ,  21 },  
  { "",                '*',   0 ,  22 },
  { "",                '(',   0 ,  23 },
  { "",                ')',   0 ,  24 },
  { "",                '_',   0 ,  25 },
  { "",                '-',   0 ,  26 },
  { "",                '+',   0 ,  27 },
  { "",                '{',   0 ,  27 },
};

void CmdMiscInit( void ) {
  miscWhoAllowLevelDisplay = INILWordRead("crimson2.ini", "whoAllowLevelDisplay", 0);
  miscWhoAllowByLevel = INILWordRead("crimson2.ini", "whoAllowByLevel", 0);
  miscWhoAllowName = INILWordRead("crimson2.ini", "whoAllowName", 0);
  miscWhoMortsSeeSomeone = INILWordRead("crimson2.ini", "whoMortalsSeeSomeone", 0);
  miscWhoLimitSomeone = INILWordRead("crimson2.ini", "whoLimitSomeoneToGods", 0);
  miscWhoImmsSeeSomeone = INILWordRead("crimson2.ini", "whoImmsSeeGodInvis", 0 );
}

CMDPROC(CmdShowskill) { /* THING *thing, BYTE *cmd */

  BYTE  word[256];
  BYTE  buf[256];
  WORD  start = 0;
  BYTE  temp  = 0;
  BYTE  level = Character(thing)->cLevel;
  LWORD t;
  LWORD skill;

  cmd = StrOneWord(cmd, NULL);
  cmd = StrOneWord(cmd, word);
  while( *word ){
    if( !start && StrIsNumber( word ) ){
        temp = atoi( word );
        if( temp >= 1 && temp <= LEVEL_GOD ){ /* see if its valid */              
          start = temp;
        }
    } else if( StrAbbrev( "?" , word ) || StrAbbrev( "help" , word ) ){
      strcpy( buf, "^wUsage: ShowSkill Flags\n"
                   "Flags:\n"
                   "   ? or Help   your reading it now :)\n"
                   "   starting level# shows in 10 level increments\n"
                   "   skillname - will just tell you the level\n"
                   "   at which you will get the skill\n");
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
      return;
    } else {
      skill = TYPEFIND( word , skillList);
      if( skill == -1 ) {
        SendAction("\n^wIm sorry but that is not a valid skill name.", thing, NULL, SEND_SRC|SEND_VISIBLE );
        SendHint("^;HINT: ShowSkill ? for options.\n", thing );
        return;
      }      
      for( t = 1; t <= LEVEL_GOD; t++ ) {
        Character(thing)->cLevel = t;
        if( SkillMaximum(thing, skill, 0, NULL) ) { /* they get it */
          sprintf( buf, "\n^wYou will get %s at Level %li\n",skillList[skill].sName, t );
          SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
          Character(thing)->cLevel = level;
          SendHint("^;HINT: ShowSkill ? for options.\n", thing );
          return;
        }
      }
      /* shouldnt get here but just in case :P */
      SendAction("\n^wIm sorry but you dont get that skill.\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
      Character(thing)->cLevel = level;
      SendHint("^;HINT: ShowSkill ? for options.\n", thing );
      return;
    }
    /* keep getting more parms */      
    cmd = StrOneWord(cmd, word);
  }
  SkillShowByLevel( thing, start );
  Character(thing)->cLevel = level; /* extraneous and unneeded since SkillShowbyLevel does it for us */
  SendHint("^;HINT: ShowSkill ? for options.\n", thing );
}

CMDPROC(CmdReport) { /* Cmd(THING *thing, BYTE *cmd) */
  BYTE  word[256];
  BYTE  *oldcmd = NULL;
  SOCK  *sock = NULL;
  BYTE   bufTarget[512];
  BYTE   bufPlayer[512];
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  LWORD  perc;
  LWORD  stat;
  LWORD  Index;
  THING *found = NULL;  
  BYTE   buf[512];
  BYTE   color[3];
  LWORD  size = 0;
  LWORD  levels; /* dont really care about this */
     
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  oldcmd = cmd;
  cmd = StrOneWord(cmd, word );
  
  for( Index = 0; Index < 3; Index++ ) {
    switch( Index ) {
    case 0:/* hitp */
      perc = CharGetHitPMax(thing);
      stat = Character(thing)->cHitP;
      break;
    case 1:/* movep */
      perc = CharGetMovePMax(thing);
      stat = Character(thing)->cMoveP;
      break;
    case 2:/* powerp */
      perc = CharGetPowerPMax(thing);
      stat = Character(thing)->cPowerP;
      break;
    }
    if( perc > 100 )
      perc = ( perc / 100 );
    else
      perc = 1;
    if( ( stat / perc ) < 50 )
      color[Index] = 'r';
    else if( ( stat / perc ) < 75 )
      color[Index] = 'y';
    else
      color[Index] = 'g'; 
  }
  sprintf( buf, "^g[^%c%li^g/%li]HP [^%c%li^g/%li]MP [^%c%li^g/%li]PP",
           color[0],
           Character(thing)->cHitP,
           CharGetHitPMax(thing),
           color[1],
           Character(thing)->cMoveP,
           CharGetMovePMax(thing),
           color[2],
           Character(thing)->cPowerP,
           CharGetPowerPMax(thing) );
  
  if( *word && StrAbbrev( "group" , word ) ) {
    if( Character(thing)->cLead )
      GroupGetStat( thing, &size, &levels );
    if( ( ( GroupIsMember( thing, thing ) ) && (
        BIT(Character(thing)->cAffectFlag,AF_GROUP) || 
       ( Character(thing)->cLead == thing && size > 1 )) )){
      sock = BaseControlFind(thing);
      /* turn group channel on */
      if (!BIT(sock->sPref, SP_CHANGROUP)) {
        SendAction("^wTurning ^cGroup ^wChannel On\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
        BITSET(sock->sPref, SP_CHANGROUP);
        Plr(sock->sHomeThing)->pSockPref = sock->sPref;
      }
      sprintf(bufTarget, "^~$n GReports \"%s\"\n", buf );
      sprintf(bufPlayer, "^~You GReport \"%s\"\n", buf );
      SendAction(bufPlayer, thing, NULL, SEND_SRC  |SEND_AUDIBLE|SEND_CAPFIRST|SEND_HISTORY);
      SendAction(bufTarget, thing, NULL, SEND_GROUP|SEND_AUDIBLE|SEND_CAPFIRST|SEND_HISTORY);      
    } else { /* not in a group ! */
      SendAction("\nYou try to Report to a group but your not in a GROUP!\n", thing, NULL, SEND_SRC|SEND_VISIBLE );        
    }
  } else if( *oldcmd ) { /* try to find someone to tell to */
    cmd = ParseFind(oldcmd, srcKey, &srcOffset, &srcNum, NULL, NULL);
    found = ThingFind(srcKey, -1, Base(thing)->bInside, TF_MOB|TF_PLR|TF_MOB_WLD|TF_PLR_WLD, &srcOffset);
    if( !found ) {
      SendAction("^wReport to who, what?\n", thing, NULL, SEND_SRC|SEND_VISIBLE );     
    } else {
      sprintf(bufTarget, "^@$n Reports to you: \"%s\"\n", buf );
      sprintf(bufPlayer, "^@You Report to $N: \"%s\"\n", buf );
      SendAction(bufPlayer, thing, found, SEND_SRC|SEND_AUDIBLE|SEND_CAPFIRST);
      SendAction(bufTarget, thing, found, SEND_DST|SEND_AUDIBLE|SEND_CAPFIRST);
    }
  } else { /* no one specified report to room */
    sprintf(bufTarget, "^6$n Reports: \"%s\"\n", buf );
    sprintf(bufPlayer, "^6You Report: \"%s\"\n", buf );    
    SendAction(bufPlayer, thing, NULL, SEND_SRC|SEND_AUDIBLE|SEND_CAPFIRST );
    SendAction(bufTarget, thing, NULL, SEND_ROOM|SEND_AUDIBLE|SEND_CAPFIRST );
  }
}

CMDPROC(CmdTitle) { /* Cmd(THING *thing, BYTE *cmd) */
  BYTE buf[512];
  BYTE *i;
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  i = StrFind(cmd, "$$n");
  while (i && i[2]=='N') i=StrFind(i+1, "$$n");
  if (i) {
    /* convert $$n into $n */
    while( *(i+1) ) {
      *i = *(i+1);
      i++;
    }
    *i = '\0'; /* copy null too */
    sprintf(buf,   "%s", cmd);
  } else {
    sprintf(buf,   "$n %s", cmd);
  }

  SendAction("^GOkay Doke, you are now:\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
  STRFREE(Base(thing)->bLDesc);
  Base(thing)->bLDesc = STRCREATE(buf); /* name & title */
  SendAction(Base(thing)->bLDesc->sText, thing, NULL, SEND_SRC|SEND_VISIBLE);
  SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
}

CMDPROC(CmdWho) { /* Cmd(THING *thing, BYTE *cmd) */
  SOCK *sock;
  SOCK *s;
  BYTE  buf[512];
  BYTE  word[256];
  const BYTE WHO_GODINVIS[] = { "^%c*---> ^gSomeone ^%c<---*^g" };
  LWORD i = 0;
  BYTE  bShowAsSomeone = FALSE;

  /* settings from ini */

  BYTE  bShowLevel = FALSE; /* wAllowLevelDisplay show chars level */
  BYTE  bShowSomeone = FALSE; /* wMortalsSeeSomeone if char is invis show as someone  */
  BYTE  bLimitSomeone = FALSE; /* wLimitSomeoneToGods only invisibile gods show as someone */
  BYTE  bImmSeeSomeone = FALSE; /* wImmsSeeGodInvis if enabled gods must be of >= level 
                         to see godinvis gods otherwise they see someone <godinvis>*/

  /* settings from flags */
  
  BYTE  bName = FALSE; /* display name only or not */
  BYTE  bInvis = FALSE; /* are they invisible with item or spell */
  BYTE  bGodInvis = FALSE; /* are they godinvis */

  /* Level variables for show by level ect .. */
  
  LWORD lLevel = 0; /* to display must be >= level */
  LWORD hLevel = LEVEL_NOBODY;/* to display must be <= hLevel */
  LWORD tLevel = 0; /* temp var */
  LWORD dLevel = 0; /* current display char level */
  LWORD uLevel = 0; /* users level ( the person doing the who of course :) */

  /* affect flags */  
  BYTE  bSeeInvis = FALSE;
   
  sock = BaseControlFind(thing);
  if (!sock) return;

  uLevel = Character(sock->sHomeThing)->cLevel; /* get users level for later use */
  if( BIT(Character(sock->sHomeThing)->cAffectFlag, AF_SEEINVIS) )
      bSeeInvis = TRUE;

  /* Read in ini settings except ones I only need once like for names */

  if( miscWhoMortsSeeSomeone )
    bShowSomeone = TRUE;
  if( miscWhoLimitSomeone )
    bLimitSomeone = TRUE;
  if( miscWhoImmsSeeSomeone )
    bImmSeeSomeone = TRUE;

  /* get flags passed in here */

  cmd = StrOneWord(cmd, word);
  while( *word ){
      if( StrAbbrev( "god" , word ) ){
          lLevel = LEVEL_GOD;
          hLevel = ( LEVEL_NOBODY - 1 );
      }else if( StrAbbrev( "name" , word ) && miscWhoAllowName ) {
        bName = TRUE;
      }else if( StrAbbrev( "level" , word ) && miscWhoAllowLevelDisplay ) {
        bShowLevel = TRUE;
      }else if( StrIsNumber( word ) && miscWhoAllowByLevel ){
        tLevel = atoi( word );
        if( tLevel >= 0 && tLevel < LEVEL_NOBODY ){ /* see if its valid */              
          if( !lLevel )
            lLevel = tLevel;
          else if( hLevel == LEVEL_NOBODY && tLevel > lLevel )
            hLevel = tLevel;
        }      
      }else if( StrAbbrev( "?" , word ) ||
                StrAbbrev( "help" , word ) ){
          strcpy( buf, "^wUsage: who Flags\n"
                         "Flags:\n"
                         "   ? or Help   your reading it now :)\n"
                         "         god   Only shows Gods\n" );
          if( miscWhoAllowName )
            strcat( buf, "        name   Name only (No title)\n" );
                         
          if ( miscWhoAllowByLevel )
            strcat( buf, "low# (high#)   Display only chars in the specified range\n"
                         "               of levels the second one is optional.\n" );
          if( miscWhoAllowLevelDisplay )
             strcat( buf,"       level   Display levels also.\n");
          SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
          return;
      }/* keep getting more parms */
      cmd = StrOneWord(cmd, word);
  }

  /* end of flags */

  SendAction("\n^pWho's on with you:\n^P-----------------\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
  for (s = sockList; s; s=s->sNext) 
  {
      if (s->sHomeThing){  /* block out those halfway thru signon */

          bShowAsSomeone = FALSE;

          /*     set flags based on user to display   */

          dLevel = Character(s->sHomeThing)->cLevel; /* current user to display level */

          if( dLevel >= LEVEL_GOD && BIT(Plr(s->sHomeThing)->pSystem,PS_GODINVIS) )
              bGodInvis = TRUE;
          else
              bGodInvis = FALSE;
          
          if( BIT(Character(s->sHomeThing)->cAffectFlag, AF_INVIS) ) /* is the char invis with a spell or item */
              bInvis = TRUE;
          else
              bInvis = FALSE;

          /* end user to display flags */

          /* find out if we should display the char at all */

          if( dLevel < lLevel || dLevel > hLevel )
              /* dont show if they arent low/high enough level to match request */
              continue;

          if( bGodInvis && !bShowSomeone && uLevel < LEVEL_GOD ) 
              /* user is not a god so cant see the god */
              continue;
          
          i++;
          if ( dLevel > LEVEL_IMMORTAL){              
              /* handle immortal stuff here */
              if (Character(s->sHomeThing)->cLevel>=LEVEL_CODER)
                  SendAction("^w IMP ^g", thing, s->sHomeThing, SEND_SRC|SEND_VISIBLE );
              else if (Character(s->sHomeThing)->cLevel>=LEVEL_SECURITY)
                  SendAction("^w IMP ^g", thing, s->sHomeThing, SEND_SRC|SEND_VISIBLE );
              else if (Character(s->sHomeThing)->cLevel>=LEVEL_ADMIN)
                  SendAction("^R ADM ^g", thing, s->sHomeThing, SEND_SRC|SEND_VISIBLE );
              else if (Character(s->sHomeThing)->cLevel>=LEVEL_STAFF)
                  SendAction("^R ADM ^g", thing, s->sHomeThing, SEND_SRC|SEND_VISIBLE );
              else if (Character(s->sHomeThing)->cLevel>=LEVEL_GOD)
                  SendAction("^P GOD ^g", thing, s->sHomeThing, SEND_SRC|SEND_VISIBLE );
              else 
                  SendAction("^bIMM ", thing, NULL, SEND_SRC|SEND_VISIBLE );
              if( bShowSomeone ){                  
                  if( bGodInvis ){
                      if( uLevel > LEVEL_IMMORTAL ){
                          if( bImmSeeSomeone && uLevel < dLevel )
                              bShowAsSomeone = TRUE;
                          /* already false otherwise no need to set */
                      }else if ( uLevel < 11 ){
                          if( (BIT(Plr(s->sHomeThing)->pSystem, PS_HELPER))){
                              bShowAsSomeone = FALSE;                              
                          }
                          else
                            bShowAsSomeone = TRUE;
                      }else
                          bShowAsSomeone = TRUE;
                  }else if( bInvis && uLevel <= LEVEL_IMMORTAL ){
                      bShowAsSomeone = TRUE;
                  }
              }
              if( bShowAsSomeone )
              {
                  if( bName )
                      strcpy( buf, "^wSomeone^g" );
                  else {
                    if ( Character(s->sHomeThing)->cLevel >= LEVEL_CODER )
                      bName = 'Y';
                    else if (Character(s->sHomeThing)->cLevel>=LEVEL_SECURITY)
                      bName = 'Y';
                    else if (Character(s->sHomeThing)->cLevel>=LEVEL_ADMIN)
                      bName = 'R';
                    else if (Character(s->sHomeThing)->cLevel>=LEVEL_STAFF)
                      bName = 'R';
                    else if (Character(s->sHomeThing)->cLevel>=LEVEL_GOD)
                      bName = 'P';
                    else
                      bName = 'B';
                    sprintf( buf, WHO_GODINVIS, bName , bName );
                    bName = FALSE;
                  }
              }else{
                  if( bName )
                      strcpy( buf, Base(s->sHomeThing)->bKey->sText );
                  else
                      strcpy( buf, Base(s->sHomeThing)->bLDesc->sText );
              }
              SendAction( buf, s->sHomeThing, thing, SEND_DST|SEND_CAPFIRST|SEND_SELF);                      
              if ( bGodInvis && uLevel > LEVEL_IMMORTAL )
                  SendAction("^w <^aGODINVIS^w>^g", thing,s->sHomeThing, SEND_SRC|SEND_VISIBLE );
          }else{    /* now the mortals */

              if( bShowLevel )
                  sprintf( buf, "^W^g %3lu ^g", dLevel ); /* unsigned long ok ? */
              else
                  strcpy(  buf, "^W^g     ^g" );

              SendAction( buf, thing,s->sHomeThing, SEND_SRC|SEND_VISIBLE ); /* */

              if( bShowSomeone       && /* are we showing invis as someone */
                  !bSeeInvis         && /* can they see invis */
                  bInvis             && /* is the person we are displaying invis */
                  uLevel < LEVEL_GOD && /* gods can always see */
                  s != sock             /* can always see yourself */
                  )
                  bShowAsSomeone = TRUE;              
              if( bShowAsSomeone )
                  strcpy( buf, "^gSomeone" );
              else if( bName )
                  strcpy( buf, Base(s->sHomeThing)->bKey->sText );
              else
                  strcpy( buf, Base(s->sHomeThing)->bLDesc->sText );

              SendAction( buf, s->sHomeThing, thing, SEND_DST|SEND_CAPFIRST|SEND_SELF);           
          }  /* end of mortal specific */
          /*   Common to both morts and gods  */
          ThingShowFlags( s->sHomeThing, thing );
          
          /* Show if they are signing on */
          if (s->sMode != MODE_PLAY){
              if ( uLevel >= LEVEL_GOD){
                  SendAction("^p <", thing,s->sHomeThing, SEND_SRC|SEND_VISIBLE );
                  SendAction(sModeList[s->sMode], thing,NULL, SEND_SRC|SEND_VISIBLE );
                  SendAction("^p>", thing, s->sHomeThing, SEND_SRC|SEND_VISIBLE );
              }else
                  SendAction("^p <SIGNING ON>", thing, s->sHomeThing, SEND_SRC|SEND_VISIBLE );
          }
      }else
          SendAction("^p<New Connect in Progress>", thing, NULL, SEND_SRC|SEND_VISIBLE );
      SendAction("^V\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  sprintf(buf, "^w%ld ^pPeople total\n", i);
  SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendHint("^;HINT: Who ? for options.\n", thing );
}

CMDPROC(CmdWhere) { /* Cmd(THING *thing, BYTE *cmd) */
  BYTE   srcKey[256];
  LWORD  srcNum;
  LWORD  srcOffset;
  THING *found;
  SOCK  *sock;
  THING *homeThing;
  BYTE   buf[256];
  BYTE   truncateStr[256];
  LWORD  i = 0;
  LWORD  area;
 
  sock = BaseControlFind(thing);
  if (!sock) return;
  homeThing = sock->sHomeThing;

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */

  SendAction("\n^pWhere on earth is everybody:\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("^P---------------------------\n", thing, NULL, SEND_SRC|SEND_VISIBLE );

  if (!Base(thing)->bInside || Base(thing)->bInside->tType != TTYPE_WLD)
    return;
  area = Wld(Base(thing)->bInside)->wArea;


  /* Show where all the players are */
  if (!*cmd) {
    for (sock = sockList; sock; sock=sock->sNext) {
      if (sock->sHomeThing 
          && Base(sock->sHomeThing)->bInside
          && Base(sock->sHomeThing)->bInside->tType == TTYPE_WLD
          && ( Wld(Base(sock->sHomeThing)->bInside)->wArea == area 
              ||Character(homeThing)->cLevel >= LEVEL_GOD )) { /* block out those halfway thru signon */
        i++;
        /* show the person */
        if (i%2)
          SendAction("  ^r", thing, NULL, SEND_SRC|SEND_VISIBLE );
        else
          SendAction("  ^R", thing, NULL, SEND_SRC|SEND_VISIBLE );
        sprintf(buf, "%-25s - ", StrTruncate(truncateStr, sock->sHomeThing->tSDesc->sText, 25));
        SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
        /* show the location */
        if (i%2)
          SendAction("^c", thing, NULL, SEND_SRC|SEND_VISIBLE );
        else
          SendAction("^C", thing, NULL, SEND_SRC|SEND_VISIBLE );
        SendAction(Base(sock->sHomeThing)->bInside->tSDesc->sText, thing, NULL, SEND_SRC|SEND_VISIBLE );
 
        /* Gods get to see the area */             
        if ( Character(homeThing)->cLevel >= LEVEL_GOD ) { 
          LWORD area;
          BYTE  word[256];
          BYTE  truncateStr[256];
 
          /* Find area name */
          area = Wld( Base(sock->sHomeThing)->bInside )->wArea;
          StrFirstWord(areaList[area].aFileName->sText,word);
          StrTruncate(truncateStr, word, 25);
          
          /* send it */
          SendAction(" (", thing, NULL, SEND_SRC|SEND_VISIBLE );
          SendAction( truncateStr, thing, NULL, SEND_SRC|SEND_VISIBLE );
          SendAction(")", thing, NULL, SEND_SRC|SEND_VISIBLE );

          sprintf(word, " [%ld]", Wld( Base(sock->sHomeThing)->bInside )->wVirtual);
          SendAction(word, thing, NULL, SEND_SRC|SEND_VISIBLE );
        }

        SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
      }
    }
    sprintf(buf, "^w%ld ^pPeople total\n", i);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }

  /* show matching mobs and plrs in the same area */
  cmd = ParseFind(cmd, srcKey, &srcOffset, &srcNum, NULL, NULL);

  found = ThingFind(srcKey, -1, Base(thing)->bInside, TF_MOB|TF_PLR|TF_MOB_WLD|TF_PLR_WLD, &srcOffset);
  if (!found) {
    SendAction("^wWhere's who?, Never heard of 'em\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  } 

  while (found && srcNum!=0 && i<50) {
    if (found
        && Base(found)->bInside
        && Base(found)->bInside->tType == TTYPE_WLD
        && ( Wld(Base(found)->bInside)->wArea == area 
            ||Character(homeThing)->cLevel >= LEVEL_GOD )) { /* block out those halfway thru signon */
      i++;
      /* show the person */
      if (i%2)
        SendAction("  ^r", thing, NULL, SEND_SRC|SEND_VISIBLE );
      else
        SendAction("  ^R", thing, NULL, SEND_SRC|SEND_VISIBLE );
      sprintf(buf, "%-25s - ", StrTruncate(truncateStr, found->tSDesc->sText, 25));
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
      /* show the location */
      if (i%2)
        SendAction("^c", thing, NULL, SEND_SRC|SEND_VISIBLE );
      else
        SendAction("^C", thing, NULL, SEND_SRC|SEND_VISIBLE );
      SendAction(Base(found)->bInside->tSDesc->sText, thing, NULL, SEND_SRC|SEND_VISIBLE );
      /* Gods get to see the area */             
      if ( (Character(homeThing)->cLevel >= LEVEL_GOD) &&
           (Base(found)->bInside) &&
           (Base(found)->bInside->tType==TTYPE_WLD) ) {
        LWORD area;
        BYTE  word[256];
        BYTE  truncateStr[256];

        /* Find area name */
        area = Wld( Base(found)->bInside )->wArea;
        StrFirstWord(areaList[area].aFileName->sText,word);
        StrTruncate(truncateStr, word, 25);
         
        /* send it */
        SendAction(" (", thing, NULL, SEND_SRC|SEND_VISIBLE );
        SendAction( truncateStr, thing, NULL, SEND_SRC|SEND_VISIBLE );
        SendAction(")", thing, NULL, SEND_SRC|SEND_VISIBLE );

        sprintf(word, " [%ld]", Wld( Base(found)->bInside )->wVirtual);
        SendAction(word, thing, NULL, SEND_SRC|SEND_VISIBLE );
      }
      SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    } else {
      if (srcNum>=0) srcNum++;
    }
    found = ThingFind(srcKey, -1, Base(thing)->bInside, TF_MOB|TF_PLR|TF_MOB_WLD|TF_PLR_WLD|TF_CONTINUE, &srcOffset);
  }
  
}


CMDPROC(CmdSave) { /* Cmd(THING *thing, BYTE *cmd) */
  SOCK *sock;

  sock = BaseControlFind(thing);
  SendAction("^wSaving your Player Data\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  PlayerWrite(sock->sHomeThing, PWRITE_CRASH);
}



/******************* CmdSet - Start ************************/

/* The following is all to do with the Set command, it's
   kind of complicated but it allows nicely formatted output and
   easy addition of arbitrary columns and rows */

#define SV_TITLE    0 /* title no flag */
#define SV_SOCKPREF 1 /* socket preference flag */
#define SV_AUTO     2 /* autoaction preference */
#define SV_SYSTEM   3 /* Player system */

FLAG *MiscSetFlag(SOCK *sock, LWORD flagNum) {
  if (!sock) return NULL;
  switch (flagNum) {
  case SV_SOCKPREF:
    return &(sock->sPref);
  case SV_SYSTEM:
    return &(Plr(sock->sHomeThing)->pSystem);
  case SV_AUTO:
    return &(Plr(sock->sHomeThing)->pAuto);
  default:
    return NULL;
  }
}
  
  #define MAX_COLUMN 4

  struct SetType expertSetList[] = {
    { "SOCKET:",    0, SV_TITLE,    0,              NULL    },
    { "Car.Ret.",   0, SV_SOCKPREF, SP_CR,          NULL    },
    { "LineFeed",   0, SV_SOCKPREF, SP_LF,          NULL    },
    { "Continue",   0, SV_SOCKPREF, SP_CONTINUE,    NULL    },
    { "TelnetGA",   0, SV_SOCKPREF, SP_TELNETGA,    NULL    },
    { "Ansi",       0, SV_SOCKPREF, SP_ANSI,        NULL    },
    { "Compact",    0, SV_SOCKPREF, SP_COMPACT,     NULL    },
    { " "       ,   0, SV_TITLE,    0,              NULL    }, /* spacer must be " " */
    { "ScreenSize", 0, SV_TITLE,    SP_COMPACT,     NULL    },
    { " "       ,   0, SV_TITLE,    0,              NULL    }, /* spacer must be " " */
    /* so people see the words */
    { "INFO:",      0, SV_TITLE,    0,              NULL    }, /* spacer must be " " */
    { "^3Description",0, SV_TITLE,  0,              NULL,   }, 
    { "^3Email",    0, SV_TITLE,    0,              NULL,   }, 
    { "^3Plan",     0, SV_TITLE,    0,              NULL,   }, 

    { "CHANNELS:",  1, SV_TITLE,    0,              NULL    },
    { "Private",    1, SV_SOCKPREF, SP_CHANPRIVATE, NULL    },
    { "Group",      1, SV_SOCKPREF, SP_CHANGROUP,   NULL    },
    { "Gossip",     1, SV_SOCKPREF, SP_CHANGOSSIP,  NULL    },
    { "Auction",    1, SV_SOCKPREF, SP_CHANAUCTION, NULL    },
    { "Usage",      1, SV_SOCKPREF, SP_CHANUSAGE,   NULL    },
    { "Tick",       1, SV_SOCKPREF, SP_CHANTICK,    NULL    },
    { "Port",       1, SV_SOCKPREF, SP_CHANPORT,    "users" },
    { "Error",      1, SV_SOCKPREF, SP_CHANERROR,   "setstat"  },
    { "God",        1, SV_SOCKPREF, SP_CHANGOD,     "stat"  },
    { "Area",       1, SV_SOCKPREF, SP_CHANAREA,    "astat" },
    { "Spy",        1, SV_SOCKPREF, SP_CHANSPY,     "reboot"  },
    { "Board",      1, SV_SOCKPREF, SP_CHANBOARD,   "blist" },

    { "PROMPT:",    2, SV_TITLE,    0,              NULL    },
    { "Hit Pts",    2, SV_SOCKPREF, SP_PROMPTHP,    NULL    },
    { "Move Pts",   2, SV_SOCKPREF, SP_PROMPTMV,    NULL    },
    { "Power Pts",  2, SV_SOCKPREF, SP_PROMPTPP,    NULL    },
    { "Name",       2, SV_SOCKPREF, SP_PROMPNAME,   NULL    },
    { "Room #'s",   2, SV_SOCKPREF, SP_PROMPTRM,    "wgoto" },
    { "Exits",      2, SV_SOCKPREF, SP_PROMPTEX,    NULL    },
    { " "       ,   2, SV_TITLE   , 0,              NULL    }, /* spacer must be " " */
    { "PREFS:",     2, SV_TITLE,    0,              NULL    },
    { "NoEmail",    2, SV_AUTO,     PA_NOEMAIL,     NULL    },
    { "Hint",       2, SV_AUTO,     PA_HINT,        NULL    },
    { "Expert",     2, SV_AUTO,     PA_EXPERT,      NULL    },
    { "NoHassle",   2, SV_SYSTEM,   PS_NOHASSLE,    "goto"  },/* changed from bload by request for level 201 access */
    { "AFK",        2, SV_AUTO,     PA_AFK,         NULL    },
    { "NoSummon",   2, SV_SYSTEM,   PS_NOSUMMON,    NULL    },
    { "NoSpam",     2, SV_SYSTEM,   PS_NOSPAM,      NULL    },
    { "Sound",      2, SV_SYSTEM,   PS_SOUND,       NULL    },   
    { "GodInvis",   2, SV_SYSTEM,   PS_GODINVIS,    "goto"  },

    { "AUTO:",      3, SV_TITLE,    0,              NULL    },
    { "AutoLook",   3, SV_AUTO,     PA_AUTOLOOK,    NULL    },
    { "AutoExit",   3, SV_AUTO,     PA_AUTOEXIT,    NULL    },
    { "AutoLoot",   3, SV_AUTO,     PA_AUTOLOOT,    NULL    },
    { "AutoAssist", 3, SV_AUTO,     PA_AUTOASSIST,  NULL    },
    { "AutoAggr",   3, SV_AUTO,     PA_AUTOAGGR,    NULL    },
    { "AutoRescue", 3, SV_AUTO,     PA_AUTORESCUE,  NULL    },
    { "AutoJunk",   3, SV_AUTO,     PA_AUTOJUNK,    NULL    },
    { "AutoFlee",   3, SV_AUTO,     PA_AUTOFLEE,    NULL    },
    { "AutoEat",    3, SV_AUTO,     PA_AUTOEAT,     NULL    },
    { "AutoDrink",  3, SV_AUTO,     PA_AUTODRINK,   NULL    },
    { "Consider",   3, SV_AUTO,     PA_CONSIDER,    NULL    },

    { ""        ,  -1, SV_TITLE,    0,              NULL    }
  };

  struct SetType newbieSetList[] = {
    { "SOCKET:",    0, SV_TITLE,    0,              NULL    },
    { "Ansi",       0, SV_SOCKPREF, SP_ANSI,        NULL    },
    { " "       ,   0, SV_TITLE,    0,              NULL    }, /* spacer must be " " */
    /* so people see the words */
    { "INFO:",      0, SV_TITLE,    0,              NULL    }, /* spacer must be " " */
    { "^3Description",0, SV_TITLE,  0,              NULL,   }, 
    { "^3Email",    0, SV_TITLE,    0,              NULL,   }, 
    { "^3Plan",     0, SV_TITLE,    0,              NULL,   }, 

    { "CHANNELS:",  1, SV_TITLE,    0,              NULL    },
    { "Private",    1, SV_SOCKPREF, SP_CHANPRIVATE, NULL    },
    { "Group",      1, SV_SOCKPREF, SP_CHANGROUP,   NULL    },
    { "Gossip",     1, SV_SOCKPREF, SP_CHANGOSSIP,  NULL    },
    { "Auction",    1, SV_SOCKPREF, SP_CHANAUCTION, NULL    },
    { "Usage",      1, SV_SOCKPREF, SP_CHANUSAGE,   NULL    },

    { "PROMPT:",    2, SV_TITLE,    0,              NULL    },
    { "Hit Pts",    2, SV_SOCKPREF, SP_PROMPTHP,    NULL    },
    { "Move Pts",   2, SV_SOCKPREF, SP_PROMPTMV,    NULL    },
    { "Power Pts",  2, SV_SOCKPREF, SP_PROMPTPP,    NULL    },
    { "Exits",      2, SV_SOCKPREF, SP_PROMPTEX,    NULL    },
    { " "       ,   2, SV_TITLE   , 0,              NULL    }, /* spacer must be " " */
    { "PREFS:",     2, SV_TITLE,    0,              NULL    },
    { "Expert",     2, SV_AUTO,     PA_EXPERT,      NULL    },

    { "AUTO:",      3, SV_TITLE,    0,              NULL    },
    { "AutoLook",   3, SV_AUTO,     PA_AUTOLOOK,    NULL    },
    { "AutoFlee",   3, SV_AUTO,     PA_AUTOFLEE,    NULL    },
    { "AutoEat",    3, SV_AUTO,     PA_AUTOEAT,     NULL    },
    { "AutoDrink",  3, SV_AUTO,     PA_AUTODRINK,   NULL    },

    { ""        ,  -1, SV_TITLE,    0,              NULL    }
  };


/* This proc goes through the thing's setting list and makes sure
 * it has permission to have all it's set's set. */
void MiscSetFlagCheck(THING *thing) {
  LWORD i;
  SOCK *sock;
  FLAG *flag;

  if (!thing)
    return;
  if (thing->tType!=TTYPE_PLR)
    return;

  sock = BaseControlFind(thing);
  if (!sock) return;
  
  for (i=0; expertSetList[i].sName[0]; i++) {
    if (expertSetList[i].sCmd) {
      /* this is a restricted flag - let's check it */
      if (!ParseCommandCheck(TYPEFIND(expertSetList[i].sCmd,commandList),sock, "")) {
        /* uh oh, clear this sucker! if it's set! */
        flag = MiscSetFlag(sock, expertSetList[i].sVariable);
        if (flag) 
          BITCLR(*flag, expertSetList[i].sFlag);
      }
    }
  }
}

CMDPROC(CmdSet) { /* Cmd(THING *thing, BYTE *cmd) */
  struct SetType * setList;
  LWORD columnIndex[MAX_COLUMN];

  BYTE  bufColumn[256];
  BYTE  bufLine[512];
  BYTE  word[256];
  FLAG *flag;
  LWORD i;
  LWORD temp;
  BYTE  notDone = TRUE;
  SOCK *sock;
  BYTE  expert = FALSE;

  /* what are we doing */
  cmd = StrOneWord(cmd, word); /* toss "set" */
  cmd = StrOneWord(cmd, word); /* grab argument (if any) */

  /* need this to change socket prefs */
  sock = BaseControlFind(thing);

  /* Determine is expert is set */
  if (sock && BIT(Plr(sock->sHomeThing)->pAuto, PA_EXPERT)) expert = TRUE;

  /* Give them appropriate list of options to change */
  if (expert)
    setList = expertSetList;
  else
    setList = newbieSetList;

  SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    
  /* See if they want to change a flag setting */
  if (*word) {
    for (i=0; setList[i].sName[0]; i++) {
      /* ignore color code to determine match */
      if (StrAbbrev(setList[i].sName, word)
      || (setList[i].sName[0]=='^' && StrAbbrev(setList[i].sName+2, word)) ) {
        if (setList[i].sCmd 
            && !ParseCommandCheck(TYPEFIND(setList[i].sCmd, commandList), sock, "")) {
          SendAction("^cI'm afraid you're not authorized to do that\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
          return;
        }
        if (setList[i].sVariable!=SV_TITLE) {
          flag = MiscSetFlag(sock, setList[i].sVariable);
          BITFLIP(*flag, setList[i].sFlag);
          sprintf(
            bufLine,
            "^3Setting ^5%s^3 to ^5%-3s^V\n",
            setList[i].sName,
            BIT(*flag, setList[i].sFlag)  ? "On" : "Off"
          );
          SendAction(bufLine, thing, NULL, SEND_SRC|SEND_VISIBLE );
          Plr(sock->sHomeThing)->pSockPref = sock->sPref;
          return;
        } else if (!strcmp(setList[i].sName, "ScreenSize")) { /* special case for screen size */
          cmd = StrOneWord(cmd, word); /* grab argument (if any) */
          if (!word) {
            SendAction("^cYes but what do you want to set it to?\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
            return;
          }
          sock->sScreenLines = atoi(word);
          MINSET(sock->sScreenLines, 5);
          temp = sock->sScreenLines;
          sprintf(bufLine, "^3Setting ^5ScreenSize^3 to ^5%ld\n", temp);
          SendAction(bufLine, thing, NULL, SEND_SRC|SEND_VISIBLE );
          Plr(sock->sHomeThing)->pScreenLines = temp;
          return;
        } else if (!strcmp(setList[i].sName, "^3Description")) {
          EditStr(sock, &sock->sHomeThing->tDesc, 512, "Player Description", EP_ENDLF);
          return;
        } else if (!strcmp(setList[i].sName, "^3Email")) {
          SendAction("^cEnter your email address:\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
          EditStr(sock, &Plr(sock->sHomeThing)->pEmail, 128, "Email Address", EP_IMMNEW|EP_ONELINE|EP_ENDNOLF);
          return;
        } else if (!strcmp(setList[i].sName, "^3Plan")) {
          EditStr(sock, &Plr(sock->sHomeThing)->pPlan, 512, "Plan Description", EP_ENDLF);
          return;
        }
      }
    }
    SendAction("^cWhat was it you wanted to set now?\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }

  /* setup to display all the settings */
  notDone = TRUE;
  for (i=0; i<MAX_COLUMN; i++) /* init all the column indices to zero */
    columnIndex[i]=0;

  /* Okay List what all the flags are currently */
  while (notDone) {
    bufLine[0] = '\0';
    notDone = FALSE;

    /* print one from each column */
    for (i = 0; i<MAX_COLUMN; i++) {
      /* find next column entry that they are authorized to see */
      while((setList[columnIndex[i]].sName[0] )
          &&( (setList[columnIndex[i]].sColumn!=i)
            ||( (setList[columnIndex[i]].sCmd)
              &&(!ParseCommandCheck(TYPEFIND(setList[columnIndex[i]].sCmd, commandList), sock, "")) 
            )))
        columnIndex[i]++;

      /* Write out column data */
      flag = MiscSetFlag(sock, setList[columnIndex[i]].sVariable);
      if (!flag) {
        if (!strcmp(setList[columnIndex[i]].sName, "ScreenSize")){  /* special case for screen size */
          temp = sock->sScreenLines;
          sprintf(bufColumn, "^3%-12s^5%-7ld", setList[columnIndex[i]].sName, temp);
        } else  /* Allow for color formats in TITLE's */
          if (setList[columnIndex[i]].sName[0] == '^')
            sprintf(bufColumn, 
                    "^%c%-19s", 
                    setList[columnIndex[i]].sName[1],
                    setList[columnIndex[i]].sName+2);
          else 
            sprintf(bufColumn, "^4%-19s", setList[columnIndex[i]].sName);
      } else {
        sprintf(
          bufColumn,
          "^3%-12s^5%-7s^V",
          setList[columnIndex[i]].sName,
          BIT(*flag, setList[columnIndex[i]].sFlag)  ? "On" : "Off"
        );
      }
      /* See if we have displayed every entry to this column */
      if (setList[columnIndex[i]].sName[0]) {
        columnIndex[i]++;/* still going */
        notDone = TRUE; /* as long as at least one column printed something keep going */
      }
      strcat(bufLine, bufColumn);
    }
    if (notDone) {
      strcat(bufLine, "\n");
      SendAction(bufLine, thing, NULL, SEND_SRC|SEND_VISIBLE );
    }
  }
  SendHint("^V\n", thing );
  SendHint("^;HINT: See also ^<SETCOLOR^;\n", thing );
}
/******************* CmdSet - End **************************/



CMDPROC(CmdSetSound) { /* Cmd(THING *thing, BYTE *cmd) */  
  LWORD i;
  BYTE  buf[256];
  BYTE  word[256];
  BYTE* onoff[] = { "Off", "On" };
  BYTE  obit,nbit;

  /* what are we doing */
  cmd = StrOneWord(cmd, word); /* toss "setsound" */
  cmd = StrOneWord(cmd, word); /* grab argument (if any) */

  /* See if they want to change a flag setting */
  if (*word) {   
    i = TYPEFIND(word,soundClass );
    if (i != -1) {
      obit = BIT( Plr(thing)->pSoundPref,(1<<i));
      cmd = StrOneWord(cmd, word); /* grab next argument (if any) */
      if( *word ) {
        if( StrAbbrev(onoff[0], word) ) {
          BITCLR( Plr(thing)->pSoundPref,(1<<i));
        } else if( StrAbbrev(onoff[1], word) ) {
          BITSET( Plr(thing)->pSoundPref,(1<<i));
        }/* ignore anything else, just leave it the same */
      } else { /* we get here just flip it then */
        BITFLIP( Plr(thing)->pSoundPref,(1<<i));
      }
      nbit = BIT( Plr(thing)->pSoundPref,(1<<i));
      strcpy( word,soundClass[i].sClassName);
      word[0]=(BYTE)toupper(word[0]);
      if( obit == nbit ) {
        sprintf( buf,"\n^3SetSound: %s is currently ^5%s\n",word, onoff[obit] );
      } else {
        sprintf( buf,"\n^3SetSound: Changed %s from ^5%s^3 to ^5%s\n",word,onoff[obit],onoff[nbit] );
      }
      SendAction( buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
      return;
    }
    /* show the available settings */
    SendAction( "^3SetSound Available Flags\n\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    i=0;
    while( *soundClass[i].sClassName ) {
      strcpy( word,soundClass[i].sClassName);
      word[0]=(BYTE)toupper(word[0]);
      sprintf( buf,"^5%-15s",word);
      i++;
      if( i > 0 && i%3 == 0 )
        strcat( buf,"\n" );
      SendAction( buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    }
    if( i%3 != 0 )
      SendAction( "\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("Pass a flag with either On or Off\n"
               "or no argument to just change from current setting\n\n",
               thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }
  /* if we get this far show the list and current settings */  
  SendAction( "^3SetSound Current Settings\n\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  i=0;
  while( *soundClass[i].sClassName ) {
    strcpy( word,soundClass[i].sClassName);
    word[0]=(BYTE)toupper(word[0]);
    nbit = BIT( Plr(thing)->pSoundPref,(1<<i));
    sprintf( buf,"^3%-12s = ^5%-5s",word, onoff[nbit] );
    i++;
    if( i%3 == 0 )
      strcat( buf,"\n" );
    SendAction( buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  if( i%3 != 0 )
    SendAction( "\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendHint("^V\n", thing );
  SendHint("^;HINT: See also ^<SETCOLOR^;\n", thing );
}

CMDPROC(CmdScore) {    /* void CmdProc(THING *thing, BYTE* cmd) */
  BYTE         buf[256];
  BYTE         buf2[256];
  BYTE         expert = FALSE;
  SOCK        *sock;
  LWORD        gain;
  LWORD        size = 0;
  LWORD        levels;
  THING*       leader;

  /* Determine is expert is set */
  sock = BaseControlFind(thing);
  if (sock && BIT(Plr(sock->sHomeThing)->pAuto, PA_EXPERT)) expert = TRUE;
 
   /* show them the stats */
  SendAction("\n^3SDesc:^4[^0", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction(thing->tSDesc->sText, thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("^4]\n^3LDesc: ^2", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction(Base(thing)->bLDesc->sText, thing, NULL, SEND_SRC);
  SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("^3Description:\n^1", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction(thing->tDesc->sText, thing, NULL, SEND_SRC|SEND_VISIBLE );
  if (thing->tType == TTYPE_PLR) {
    SendAction("^3Class:^4[^5", thing, NULL, SEND_SRC|SEND_VISIBLE );
    TYPESPRINTF(buf2, Plr(thing)->pClass, classList, sizeof(buf2));
    strcat(buf2, "^4]");
    sprintf(buf, "%-13s ", buf2);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("        ^3Race:^4[^5", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction(TYPESPRINTF(buf, Plr(thing)->pRace, raceList, sizeof(buf)), thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("^4]\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  sprintf(buf, "^3Level:^4[^5%4hd^4] ", Character(thing)->cLevel);
  SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  if (expert) {
    sprintf(buf, "              ^3Aura:^4[^5%4hd^4]", Character(thing)->cAura);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  SendAction("               ^3Sex:^4[^5", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction(TYPESPRINTF(buf, Character(thing)->cSex, sexList, 512), thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("^4]\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  
  sprintf(buf, "^3Armor:^4[^5%4hd^4] ", Character(thing)->cArmor);
  SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  if (expert) {
    sprintf(buf, "              ^3HitBonus:^4[^5%4ld^4] ", CharGetHitBonus(thing, Character(thing)->cWeapon));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, "          ^3DamBonus:^4[^5%4ld^4]", CharGetDamBonus(thing, Character(thing)->cWeapon));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  sprintf(buf2, "^3Money:^4[^5%ld^4] ", Character(thing)->cMoney);
  sprintf(buf, "%-34s ", buf2);
  SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  if (thing->tType == TTYPE_PLR) {
    sprintf(buf2, "^3Bank:^4[^5%ld^4] ", Plr(thing)->pBank);
    sprintf(buf, "%-34s ", buf2);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  sprintf(buf, "^3Exp:^4[^5%ld^4/^5%ld^4]\n", Character(thing)->cExp, PlayerExpNeeded(thing));
  SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  if (thing->tType == TTYPE_PLR) {
    sprintf(buf2, "^3Fame:^4[^5%hd^4] ", Plr(thing)->pFame);
    sprintf(buf, "%-34s ", buf2);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );

    sprintf(buf, "^3Infamy:^4[^5%hd^4]\n", Plr(thing)->pInfamy);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  if (thing->tType == TTYPE_PLR && expert) {
    gain = raceList[Plr(thing)->pRace].rGainHunger;
    gain = CharGainAdjust(thing, GAIN_HUNGER, gain);
    MINSET(gain, 1);
    SendAction("\n^5Your Abilities are currently:\n^3", thing, NULL, SEND_SRC|SEND_VISIBLE );    
    sprintf(buf, "^3Str: ^4[^5%4hd^4]                ^3HP:^4[^5%5ld^4/^5%5ld^3]          ^3Hunger:^4[^5%hd/%hd^4] +^5%ld^4/tick\n", 
            Plr(thing)->pStr, 
            Character(thing)->cHitP,
            CharGetHitPMax(thing),
            Plr(thing)->pHunger,
            raceList[Plr(thing)->pRace].rMaxHunger,
            gain
    );
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    gain = raceList[Plr(thing)->pRace].rGainThirst;
    gain = CharGainAdjust(thing, GAIN_THIRST, gain);
    MINSET(gain, 1);
    sprintf(buf, "^3Dex: ^4[^5%4hd^4]                ^3MP:^4[^5%5ld^4/^5%5ld^3]          ^3Thirst:^4[^5%hd/%hd^4] +^5%ld^4/tick\n", 
            Plr(thing)->pDex, 
            Character(thing)->cMoveP, 
            CharGetMovePMax(thing),
            Plr(thing)->pThirst,
            raceList[Plr(thing)->pRace].rMaxThirst,
            gain
    );
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, "^3Con: ^4[^5%4hd^4]                ^3PP:^4[^5%5ld^4/^5%5ld^3]          ^3Intox: ^4[^5%hd/%hd^4] -^5%hd^4/tick\n", 
            Plr(thing)->pCon, 
            Character(thing)->cPowerP, 
            CharGetPowerPMax(thing),
            Plr(thing)->pIntox,
            raceList[Plr(thing)->pRace].rMaxIntox,
            raceList[Plr(thing)->pRace].rGainIntox
    );
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, "^3Wis: ^4[^5%4hd^4]\n", Plr(thing)->pWis);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, "^3Int: ^4[^5%4hd^4]                ^3Practices:^4[^5%ld^4]\n", 
            Plr(thing)->pInt,
            Plr(thing)->pPractice);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  } else {
    sprintf(buf, "^3HP:^4[^5%5ld^4/^5%5ld^3]\n", 
            Character(thing)->cHitP,
            CharGetHitPMax(thing));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, "^3MP:^4[^5%5ld^4/^5%5ld^3]\n", 
            Character(thing)->cMoveP, 
            CharGetMovePMax(thing));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, "^3PP:^4[^5%5ld^4/^5%5ld^3]", 
            Character(thing)->cPowerP, 
            CharGetPowerPMax(thing));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  if (expert) {
    SendAction("\nYour Resistances are:\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, 
            "^3Puncture  ^4[^5%3hd^4]",
            CharGetResist(thing, FD_PUNCTURE));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, 
            "            ^3Slash ^4[^5%3hd^4]",
              CharGetResist(thing, FD_SLASH));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, 
            "               ^3Concussive^4[^5%3hd^4]\n",
              CharGetResist(thing, FD_CONCUSSIVE));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, 
            "^3Heat      ^4[^5%3hd^4]",
              CharGetResist(thing, FD_HEAT));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, 
            "            ^3EMR   ^4[^5%3hd^4]",
              CharGetResist(thing, FD_EMR));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, 
            "               ^3Laser     ^4[^5%3hd^4]\n",
              CharGetResist(thing, FD_LASER));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, 
            "^3Psychic   ^4[^5%3hd^4]",
              CharGetResist(thing, FD_PSYCHIC));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, 
            "            ^3Acid  ^4[^5%3hd^4]",
              CharGetResist(thing, FD_ACID));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, 
            "               ^3Poison    ^4[^5%3hd^4]\n",
              CharGetResist(thing, FD_POISON));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    strcpy( buf," " );
    /* bypass LOG at start */
    for( gain = 1 ;*pSystemList[gain]; gain++ ) {
      if( gain == 3 ) /* skip crashsaved */
        continue;
      if( BIT(Plr(thing)->pSystem, 1<<gain ) ) {
        strcat( buf, pSystemList[gain] );
        strcat( buf," " );
      }
    }
    SendAction("\n^3Currently Set Flags: ^4[^5", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction( buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("^4]", thing, NULL, SEND_SRC|SEND_VISIBLE );
    if( Character(thing)->cLead ) {
      GroupGetStat( thing, &size, &levels );
      if( BIT(Character(thing)->cAffectFlag,AF_GROUP) || 
        ( Character(thing)->cLead == thing && size > 1 ) ) {
        if( Character(thing)->cLead != thing ) {
          leader = GroupGetLeader( thing );
          sprintf( buf,"\n^3Group Stats:   Size ^4= ^5%li^3   Total Levels ^4= ^5%li^3   Leader ^4= ^5%s", 
            size, levels, leader->tSDesc->sText );
        } else {
          sprintf( buf,"\n^3Your Groups Stats:   Size ^4= ^5%li^3   Total Levels ^4= ^5%li", size, levels );
        }
        SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE  );
      } 
      if( Character(thing)->cLead == thing ) {      
        size = 0;
        /* handle followers but not grouped here,*/
        strcpy( buf,"^5 " );
        for( leader = Character(thing)->cFollow; leader != NULL; leader = Character(leader)->cFollow ) {
          if( !BIT(Character(leader)->cAffectFlag,AF_GROUP) ) {
            size++;
            strcat( buf, leader->tSDesc->sText );
            strcat( buf,"^5  " );
          }
        }
        if( size > 0 ) {        
          SendAction( "\n^3Followers ^4:", thing, NULL, SEND_SRC|SEND_VISIBLE  );
          SendAction( buf, thing, NULL, SEND_SRC|SEND_VISIBLE  );
        }
        size = 0;
        /* handle grouped members here,*/
        strcpy( buf,"^5 " );
        for( leader = Character(thing)->cFollow; leader != NULL; leader = Character(leader)->cFollow ) {
          if( BIT(Character(leader)->cAffectFlag,AF_GROUP) ) {
            size++;
            strcat( buf, leader->tSDesc->sText );
            strcat( buf,"^5  " );
          }
        }
        if( size > 0 ) {        
          SendAction( "\n^3Group Members ^4:", thing, NULL, SEND_SRC|SEND_VISIBLE  );
          SendAction( buf, thing, NULL, SEND_SRC|SEND_VISIBLE  );
        }
      } else if( Character(thing)->cLead ) {
        sprintf( buf,"\n^3You are currently following ^4:  ^5%s^3", Character(thing)->cLead->tSDesc->sText  );
        SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE  );
      }
    }    
    SendAction("\n^3Affected by: ^4[^5", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction(FlagSprintf(buf, Character(thing)->cAffectFlag, affectList, ' ', 256), thing,NULL, SEND_SRC|SEND_VISIBLE);
    SendAction("^4]", thing, NULL, SEND_SRC|SEND_VISIBLE );
    if (Character(thing)->cAffect) {
      SendHint("\n^;HINT: You can see what is affecting you by typing ^<AFFECT^;", thing );
    }
  }
  SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
}


CMDPROC(CmdAlias) { /* Cmd(THING *thing, BYTE *cmd) */
  ALIAS *alias;
  SOCK  *sock;
  BYTE   buf[512];
  BYTE   word[256];
  LWORD  i;
  
  sock = BaseControlFind(thing);
  if (!sock) return;
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (!*cmd) {
    SendAction("^5Pattern     Action\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("^4=======     ======\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    for (i=0; i<sock->sAliasIndex.iNum; i++) {
      sprintf(buf, "^3%-10s ^4= ^b%s\n", 
        Alias(sock->sAliasIndex.iThing[i])->aPattern->sText,
        Alias(sock->sAliasIndex.iThing[i])->aAction->sText);
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    }
    SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    sprintf(buf, "^5%ld Aliases listed.\n", sock->sAliasIndex.iNum);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }

  cmd = StrOneWord(cmd, word);
  alias = AliasFind(&sock->sAliasIndex, word);
  if (*cmd) {
    if (alias) {
      sprintf(buf, "^5Overwriting ^3old Alias %s\n", alias->aPattern->sText);
      ALIASFREE(&sock->sAliasIndex, alias);
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    }
    alias = AliasCreate(&sock->sAliasIndex, word, cmd);
    if (!alias) {
      SendAction("^wI'm sorry you allready have too many aliases to create another\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
      return;
    }
    sprintf(buf, "^3Creating %s = %s\n", alias->aPattern->sText, cmd);
  } else if (alias) {
    sprintf(buf, "^3Deleting Alias %s\n", alias->aPattern->sText);
    ALIASFREE(&sock->sAliasIndex, alias);
  }
  SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  AliasWrite(sock);
}

CMDPROC(CmdUnAlias) { /* Cmd(THING *thing, BYTE *cmd) */
  ALIAS *alias;
  SOCK  *sock;
  BYTE   buf[256];
  
  sock = BaseControlFind(thing);
  if (!sock) return;
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (!*cmd) {
    CmdAlias(thing, ""); /* get list */
    return;
  }

  cmd = StrOneWord(cmd, buf);
  alias = AliasFind(&sock->sAliasIndex, buf);
  if (alias) {
    sprintf(buf, "^3Deleting Alias %s\n", alias->aPattern->sText);
    ALIASFREE(&sock->sAliasIndex, alias);
    AliasWrite(sock);
  } else
    sprintf(buf, "^gNo such Alias\n");

  SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
}

CMDPROC(CmdTime) { /* Cmd(THING *thing, BYTE *cmd) */
  BYTE  buf[256];
  LWORD timeSinceReset;
  LWORD timeUntilReset;
  LWORD area;

  SendAction("^CUptime: ^g    ", thing, NULL, SEND_SRC|SEND_VISIBLE );
  TimeSprintf(buf, time(0)-startTime);
  SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );

  if (Base(thing)->bInside && Base(thing)->bInside->tType==TTYPE_WLD) {
    area = Wld(Base(thing)->bInside)->wArea;
    SendAction("\n^CArea Reset: ^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
    if (areaList[area].aResetDelay <= 0) {
      SendAction("^rNever!\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    } else {
      timeSinceReset = time(0) - areaList[area].aResetLast - startTime;
      timeUntilReset = areaList[area].aResetDelay*60 - timeSinceReset;
      if (timeUntilReset <= 0) {
        SendAction("^wAny Time!\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
      } else {
        TimeSprintf(buf, timeUntilReset);
        SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
        SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
      }
    }
  }
  SendAction("^CReboot in: ^g ", thing, NULL, SEND_SRC|SEND_VISIBLE );
  if (sockRebootTime) {
    TimeSprintf(buf, sockRebootTime-time(NULL));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    if (sockRebootCause[0])
      SendThing(sockRebootCause,thing);
  } else if (sockRebootTimeMsg==REBOOT_WHENEMPTY) {
    SendAction("WHEN EMPTY (when nobody is logged on)\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    if (sockRebootCause[0])
      SendThing(sockRebootCause,thing);
  } else {
    SendAction("NEVER (no reboot currently scheduled)\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    /* note: we do NOT send the cause in the NEVER case because 
     * it could HAVE a cause (if it's recompiling) but we don't
     * want to tell the users this yet because there may NOT be
     * a reboot, and this would cause confusion. */
  }
}

CMDPROC(CmdEnterMsg) { /* Cmd(THING *thing, BYTE *cmd) */
  BYTE buf[512];
  BYTE *i;

  if (thing->tType!=TTYPE_PLR) return;
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (!*cmd) {
    SendAction("^GYour Entrance message is currently:\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction(Plr(thing)->pEnter->sText, thing, NULL, SEND_SRC);
    return;
  }

  i = StrFind(cmd, "$$n");
  while (i && i[2]=='N') i=StrFind(cmd, "$$n");
  if (i) {
    /* convert $$n into $n */
    while( *(i+1) ) {
      *i = *(i+1);
      i++;
    }
    *i = '\0'; /* copy null too */
    sprintf(buf,   "%s\n", cmd);
  } else {
    sprintf(buf,   "$n %s\n", cmd);
  }

  SendAction("^GOkay Doke, your entrance message is now:\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
  STRFREE(Plr(thing)->pEnter);
  Plr(thing)->pEnter = STRCREATE(buf); /* name & title */
  SendAction(Plr(thing)->pEnter->sText, thing, NULL, SEND_SRC);
}

CMDPROC(CmdExitMsg) { /* Cmd(THING *thing, BYTE *cmd) */
  BYTE buf[512];
  BYTE *i;

  if (thing->tType!=TTYPE_PLR) return;
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (!*cmd) {
    SendAction("^GYour exit message is currently:\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction(Plr(thing)->pExit->sText, thing, NULL, SEND_SRC);
    return;
  }

  i = StrFind(cmd, "$$n");
  while (i && i[2]=='N') i=StrFind(cmd, "$$n");
  if (i) {
    /* convert $$n into $n */
    while( *(i+1) ) {
      *i = *(i+1);
      i++;
    }
    *i = '\0'; /* copy null too */
    sprintf(buf,   "%s\n", cmd);
  } else {
    sprintf(buf,   "$n %s\n", cmd);
  }

  SendAction("^GOkay Doke, your exit message is now:\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
  STRFREE(Plr(thing)->pExit);
  Plr(thing)->pExit = STRCREATE(buf); /* name & title */
  SendAction(Plr(thing)->pExit->sText, thing, NULL, SEND_SRC);
}

CMDPROC(CmdPrompt) { /* Cmd(THING *thing, BYTE *cmd) */
  if (thing->tType!=TTYPE_PLR) return;
  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  if (!*cmd) {
    SendAction("^GRestoring default settable prompt:\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
    STRFREE(Plr(thing)->pPrompt);
    Plr(thing)->pPrompt = STRCREATE("");

    SendAction("\n^GCustom prompt variables are ie (%<letter>):\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("h hitpoints         m move\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("p power             H max hits\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("M max move          P max power\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("t thirst            n hunger\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("u aura              c credits\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("i intox             R room#\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("e exits             a areaname\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("N name              f fighting\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("l leadername        w weaponname\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("b hitbonus          B dambonus\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("r Armor             E total experience\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("L XP to Next level\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendHint("\n^;HINT: A typical prompt would be: ^<^^gH%h/%H M%m/%M P%p/%P ^^G-+^^C>\n", thing );
    return;
  }

  SendAction("^GOkay Doke, your prompt message is now:\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
  STRFREE(Plr(thing)->pPrompt);
  Plr(thing)->pPrompt = STRCREATE(cmd);
  SendAction(Plr(thing)->pPrompt->sText, thing, NULL, SEND_SRC);
  SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
}

CMDPROC(CmdFinger) {
  BYTE   readPlayer = FALSE;
  THING *player;
  BYTE   buf[256];

  cmd = StrOneWord(cmd, NULL); /* lose the command at the start */
  player = PlayerFind(cmd);
  if (!player) {
    player = PlayerRead(cmd, PREAD_SCAN);
    readPlayer = TRUE;
  }
  if (!player) {
    SendAction("^wFinger who exactly?!?\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }

  SendAction("You finger $N\n", thing, player, SEND_SRC);
  if (readPlayer || Character(thing)->cLevel >= LEVEL_GOD) {
    sprintf(buf, "^gLevel:^G[^c%4hd^G] ", Character(player)->cLevel);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  } else {
    sprintf(buf, "^G[^c%s^G] ", PlayerGetLevelDesc(player));
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  SendAction("^gClass:^G[", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction(TYPESPRINTF(buf, Plr(player)->pClass, classList, sizeof(buf)), thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("^G] ^gRace:^G[", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction(TYPESPRINTF(buf, Plr(player)->pRace, raceList, sizeof(buf)), thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("^G]\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  if (readPlayer) {
    SendAction("^wOffline        ^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
    TimeSprintf(buf, time(0)-Plr(player)->pTimeLastOn);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  } else {
    sprintf(buf, "^wIdle %ld Ticks\n", Plr(player)->pIdleTick);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  SendAction("^wTotal Playtime ^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
  TimeSprintf(buf, Plr(player)->pTimeTotal);
  SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );

  if (Character(thing)->cLevel >= LEVEL_ADMIN) {
    SendAction("^wLast Login:    ^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction(Plr(player)->pLastLogin->sText, thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  }

  /* send their email if they have one */
  SendAction("^CEmail:\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
  if (BIT(Plr(player)->pAuto, PA_NOEMAIL) && Character(thing)->cLevel<LEVEL_ADMIN)
    SendAction("^r<Private>", thing, NULL, SEND_SRC|SEND_VISIBLE );
  else if (*Plr(player)->pEmail->sText)
    SendAction(Plr(player)->pEmail->sText, thing, NULL, SEND_SRC|SEND_VISIBLE );
  else
    SendAction("^r<None>", thing, NULL, SEND_SRC|SEND_VISIBLE );

  /* send their plan if they have one */
  SendAction("\n^CPlan:\n^g", thing, NULL, SEND_SRC|SEND_VISIBLE );
  if (*Plr(player)->pPlan->sText)
    SendAction(Plr(player)->pPlan->sText, thing, NULL, SEND_SRC|SEND_VISIBLE );
  else
    SendAction("^r<None>", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  
  if (readPlayer)
    THINGFREE(player);
}

/* Theoretically quite a simple little command, but then I wanted 3 nicely
  formatted columns so simplicity and readability went to hell... ah well */
CMDPROC(CmdLevels) { /* Cmd(THING *thing, BYTE *cmd) */
  LWORD i;
  LWORD level;
  LWORD realLevel;
  BYTE  buf[256];

  if (thing->tType != TTYPE_PLR) {
    SendAction("^wI'm afraid you cant go up in level...\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }
  SendAction("^CLevels and the experience points required for them...\n\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  realLevel = Character(thing)->cLevel;
  level = Character(thing)->cLevel-1;
  for (i=0; i<10; i++) {
    Character(thing)->cLevel=level;
    if (level < LEVEL_GOD) {
      sprintf(buf, "^w%4ld ^y%13ld       ", level+1, PlayerExpNeeded(thing));
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    } else {
      sprintf(buf, "^w%4ld ^g<GOD>\n", level+1);
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
      break;
    }
    level+=10;

    Character(thing)->cLevel=level;
    if (level < LEVEL_GOD) {
      sprintf(buf, "^w%4ld ^y%13ld       ", level+1, PlayerExpNeeded(thing));
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    }
    level+=10;

    Character(thing)->cLevel=level;
    if (level < LEVEL_GOD) {
      sprintf(buf, "^w%4ld ^y%13ld\n", level+1, PlayerExpNeeded(thing));
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    } else 
      SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    level-=19;
  }
  Character(thing)->cLevel = realLevel;
}

CMDPROC(CmdSkillMax) {
  BYTE  buf[256];
  LWORD level;

  if (thing->tType!=TTYPE_PLR) return;
  cmd = StrOneWord(cmd, NULL);
  cmd = StrOneWord(cmd, buf);
  if (!*buf) {
    SendAction("^gSkillMax shows you the maximum skills you can have for a given level\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendAction("^gUsage: SkillMax <level>\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }
  level = Character(thing)->cLevel;
  Character(thing)->cLevel = atol(buf);
  sprintf(buf, "pr %s", cmd);
  SkillShow(thing, NULL, buf, 0, 0xFFFFFFFF, 200); /* Thing, Cmd, CanPractice, CantPractice, maxLevel */
  Character(thing)->cLevel = level;
}

CMDPROC(CmdAffects) { /* Cmd(THING *thing, BYTE *cmd) */
  AFFECT *affect;
  BYTE    buf[512];

  SendAction("\n^pYou are currently affected by:\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("^P-+- +-+ -+-+-+-+- +-+-+-+- +-\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  for (affect = Character(thing)->cAffect; affect; affect=affect->aNext) {    
    sprintf(buf, "^3%-20s %hd\n", effectList[affect->aEffect].eName, affect->aDuration);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
  SendAction("\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("^3AffectFlags:^4[^5", thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction(FlagSprintf(buf, Character(thing)->cAffectFlag, affectList, ' ', 512), thing, NULL, SEND_SRC|SEND_VISIBLE );
  SendAction("^4]\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
}

/* 
 * Stop affects, things like Spiritwalk, Invis etc that you might
 * want to wear off prematurely
 */
CMDPROC(CmdStop) {
  /* match the name of the effect here */
  BYTE *stopList[] = {
    "Spiritwalk",
    "Invisibility",
    "ImprovedInvis",
    "Mindlink",
    "PhantomEye",
    "PhantomEar",
    "\0"
  };

  LWORD   i;
  BYTE    buf[256];
  AFFECT *affect;
  
  cmd = StrOneWord(cmd, NULL);
  cmd = StrOneWord(cmd, buf);
  if (!*buf) {
    SendAction("^5Stoppable Affects are:\n^3", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SENDARRAY(stopList, 6, thing );
    return;
  }

  i = TYPEFIND(buf, stopList);
  if (i==-1) {
    SendAction("^wI'm afraid that is not a stoppable affect\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }
  /* Find the affect and set its duration to 0 - get rid of it */
  i = TYPEFIND(buf, effectList);
  if (i==-1) {
    SendAction("^wThe sysadmin has corrupted the stopList, what a loser!\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }  
  affect = AffectFind(thing, (long)*(effectList[i].eCheck) );
  if (!affect) {
    SendAction("^wBut you're not being affected by that right now!\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    SendHint("^;HINT: Type ^<AFFECT^; for a list of things you are being affected by\n", thing );
    return;
  }

  AffectRemove(thing, affect);
}

void MiscGetColorName(BYTE *name, BYTE fg, BYTE bg) {
  LWORD i;
  LWORD j;

  bg = toupper(bg);
  for (i=0; *ansiFGColorList[i].cName && ansiFGColorList[i].cSymbol!=fg; i++);
  for (j=0; *ansiBGColorList[j].cName && ansiBGColorList[j].cSymbol!=bg; j++);
  sprintf(name, "%s-On-%s", ansiFGColorList[i].cName, ansiBGColorList[j].cName);
}

BYTE MiscGetColorSymbol(BYTE *name, BYTE *fg, BYTE *bg) {
  LWORD i;
  LWORD j;
  BYTE  buf[256];

  if (strlen(name)==4 && name[0]=='^' && name[1]=='&') {
    /* should validate against colorlist */
    for (i=0; *ansiFGColorList[i].cName && ansiFGColorList[i].cSymbol!=name[2]; i++);
    for (j=0; *ansiBGColorList[j].cName && ansiBGColorList[j].cSymbol!=name[3]; j++);
    if (!*ansiFGColorList[i].cName) return FALSE;
    if (!*ansiFGColorList[j].cName) return FALSE;
    *fg = name[2];
    *bg = name[3];
    return TRUE;
  }
  if (strlen(name)==2 && name[0]=='^') {
    /* should validate against colorlist */
    for (i=0; *ansiFGColorList[i].cName && ansiFGColorList[i].cSymbol!=name[1]; i++);
    if (!*ansiFGColorList[i].cName) return FALSE;
    *fg = name[1];
    *bg = 'A';
    return TRUE;
  }

  for (j=0; *ansiBGColorList[j].cName; j++) {
    for (i=0; *ansiFGColorList[i].cName; i++) {
      MiscGetColorName(buf, ansiFGColorList[i].cSymbol, ansiBGColorList[j].cSymbol);
      if (StrAbbrev(buf, name)) {
        *fg = ansiFGColorList[i].cSymbol;
        *bg = ansiBGColorList[j].cSymbol;
        return TRUE;
      }
    }
  }
  return FALSE;
}

COLORPREF *MiscGetPlayerPref(THING *thing, LWORD i) {
  LWORD pColorIndex;
  pColorIndex = colorPrefList[i].wOrder;
  return & Plr(thing)->pColorPref[pColorIndex];
}

LWORD MiscGetColorIndexBySymbol( BYTE cSymbol ) {
  LWORD  pColorIndex = 0;
  while ( *colorPrefList[pColorIndex].cName ) {
    if( colorPrefList[pColorIndex].cSymbol == cSymbol )
      return colorPrefList[pColorIndex].wOrder;
    pColorIndex++;
  }
  return 0; /* shouldnt ever get here */
}

/* Set the color prefs */
CMDPROC(CmdSetColor) {  /* Cmd(THING *thing, BYTE *cmd) ? */
  SOCK* sock;
  LWORD i;
  LWORD j;
  BYTE  buf[256];
  BYTE  word[256];
  LWORD numSent;

  if (thing->tType != TTYPE_PLR)
    return;

  sock = BaseControlFind(thing);
  if( !sock ) return;

  cmd = StrOneWord(cmd, NULL);
  if (!*cmd) {
    SendAction("\n^5Color Preferences:\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    /* show the list of current color prefs */
    i=0;
    j=0;
    while ( *colorPrefList[i].cName ) { /* check for invalid colors */
      switch( MiscGetPlayerPref(thing, i)->cFG ) {
        case 'w':case 'a':case 'r':case 'y':case 'g':case 'b':case 'c':case 'p':
        case 'W':case 'A':case 'R':case 'Y':case 'G':case 'B':case 'C':case 'P':
          break;
        default: /// invalid so make it the default color
          MiscGetPlayerPref(thing, i)->cFG = 'p';
      }
      switch( MiscGetPlayerPref(thing, i)->cBG ){
        case 'w':case 'a':case 'r':case 'y':case 'g':case 'b':case 'c':case 'p':
        case 'W':case 'A':case 'R':case 'Y':case 'G':case 'B':case 'C':case 'P':
          break;
        default: /// invalid so make it the default color
          MiscGetPlayerPref(thing, i)->cBG  = 'W';
      }
      i++;
    }
    i = 0;
    while (*colorPrefList[i].cName || *colorPrefList[j].cName) {
      while (*colorPrefList[i].cName && colorPrefList[i].cColumn != 0)
        i++;
      while (*colorPrefList[j].cName && colorPrefList[j].cColumn != 1)
        j++;
      if (*colorPrefList[i].cName ){
        MiscGetColorName(word, MiscGetPlayerPref(thing, i)->cFG, MiscGetPlayerPref(thing, i)->cBG);
        if( StrExact( "GodTalk:" , colorPrefList[i].cName ) ) {
          if( ParseCommandCheck(TYPEFIND("godtalk", commandList), sock, ""))
            sprintf(buf, "^V^3%-18s^%c%-18s^V    ", colorPrefList[i].cName, colorPrefList[i].cSymbol, word);
          else /* not high enough skip it */
            sprintf(buf, "^V%-40c", ' ');
        } else {
          sprintf(buf, "^V^3%-18s^%c%-18s^V    ", colorPrefList[i].cName, colorPrefList[i].cSymbol, word);
  }
        i++;
      } else
        sprintf(buf, "^V%-40c", ' ');
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
      if (*colorPrefList[j].cName ) {
        MiscGetColorName(word, MiscGetPlayerPref(thing, j)->cFG, MiscGetPlayerPref(thing, j)->cBG);
        if( StrExact( "GodTalk:" , colorPrefList[j].cName ) ) {
          if( ParseCommandCheck(TYPEFIND("godtalk", commandList), sock, ""))
            sprintf(buf, "^V^3%-18s^%c%-18s^V\n", colorPrefList[j].cName, colorPrefList[j].cSymbol, word);
          else/* not high enough skip it */
            strcpy(buf, "^V\n");
        } else
          sprintf(buf, "^V^3%-18s^%c%-18s^V\n", colorPrefList[j].cName, colorPrefList[j].cSymbol, word);
        j++;          
      } else
        strcpy(buf, "^V\n");
      SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
    }
    return;
  }
  cmd = StrOneWord(cmd, word);
  i = TYPEFIND(word, colorPrefList);
  if (i == -1) {
    SendAction("^wThat isnt a valid preference name\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    return;
  }
  if (!*cmd) {  /* Show all the possible colors they could choose */
    SendAction("^5Available Colors Are:\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
    numSent = 0;
    for (j=0; *ansiBGColorList[j].cName; j++) {
       for (i=0; *ansiFGColorList[i].cName; i++) {
          if (ansiBGColorList[j].cFG != ansiFGColorList[i].cFG) {
            MiscGetColorName(word, ansiFGColorList[i].cSymbol, ansiBGColorList[j].cSymbol);
            sprintf(buf, "^&%c%c%-20s", ansiFGColorList[i].cSymbol, ansiBGColorList[j].cSymbol, word);
            /* strcpy(buf, word); */
            numSent++;
            if (numSent%4==0)
              strcat(buf, "\n");
            SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
          }
        }
      }
    return;
  }
  /* okay pick a setting and change its color */
  if (!MiscGetColorSymbol(cmd, &MiscGetPlayerPref(thing, i)->cFG, &MiscGetPlayerPref(thing, i)->cBG)) {
    SendAction("^wThat is not a valid color name\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  } else {
    MiscGetColorName(word, MiscGetPlayerPref(thing, i)->cFG, MiscGetPlayerPref(thing, i)->cBG);
    sprintf(buf, "^3Okey doke, from on it's %s ^%c%-20s\n", 
      colorPrefList[i].cName, colorPrefList[i].cSymbol, word);
    SendAction(buf, thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
}

CMDPROC(CmdQuit) { /* Cmd(THING *thing, BYTE *cmd) */
  SOCK *sock;

  if (strcmp(cmd, "quit") == 0) {
    sock = BaseControlFind(thing);
    if (sock) {
      if (sock->sControlThing != sock->sHomeThing)
        CmdSwitch(thing, "");
      else
        sock->sMode = MODE_MAINMENU;
      SendAction(fileList[FILE_QUIT].fileStr->sText, thing, NULL, SEND_SRC|SEND_VISIBLE );
      if (thing->tType == TTYPE_MOB && Mob(thing)->mTemplate == spiritTemplate)
        THINGFREE(thing);
    }
  } else {
    SendAction("^GType ^gQUIT ^Gno less, no more to quit\n", thing, NULL, SEND_SRC|SEND_VISIBLE );
  }
}

