#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <fcntl.h>
#ifndef WIN32
  #include <unistd.h>
  #include <dirent.h>
#else
  #include <io.h>
  #include <direct.h>
#endif
#include <ctype.h>

#include "crimson2.h"
#include "macro.h"
#include "mem.h"
#include "dirlist.h"


LWORD DirlistOpen(DIRLIST *d, BYTE *dPath, BYTE *dMask) {
  memset( d, 0, sizeof(*d) );
  strcpy(d->dPath, dPath);
  strcpy(d->dMask, dMask);
#ifdef WIN32
#else
  d->dDir = opendir(d->dPath);
  if (!d->dDir) d->dError = -1;
#endif
  return d->dError!=-1;
}

LWORD  DirlistGetNext(DIRLIST *d, BYTE *name) {
#ifndef WIN32
  d->dEnt = readdir(d->dDir);
  if (d->dEnt) {
    /* Capture some data */
    strcpy(name, d->dEnt->d_name);
    strcpy(d->dName, d->dEnt->d_name);
    d->dError = 0;
  } else
    d->dError = -1;

#else
  if (d->dFindHandle==-1) 
    d->dError = -1;
  else if (!d->dReadFirst) {
    BYTE buf[256];
    sprintf(buf, "%s\\%s", d->dPath, d->dMask);
    d->dFindHandle = _findfirst( buf, &d->dFind );
    d->dError = (d->dFindHandle==-1);
    d->dReadFirst = TRUE;
  } else {
    d->dError = _findnext( d->dFindHandle, &d->dFind);
  }

  /* Capture some data */
  if (d->dError != -1) {
    strcpy(name, d->dFind.name);
    strcpy(d->dName, d->dFind.name);
  }
#endif

  return d->dError!=-1;
}

void  DirlistClose(DIRLIST *d) {
#ifndef WIN32
  if (d->dDir) closedir(d->dDir);
  d->dDir = NULL;
#else 
  _findclose(d->dFindHandle);
  d->dFindHandle = -1;
#endif
}

