/* Crimson2 Mud Server 
 * All source written/copyright Ryan Haksi 1995 *
 * This source code is proprietary, if you are using it without my express
 * permission you are violating the copyright act and can potentially be
 * sued.
 * That said, if you would like to use it, I'm not an ogre, gimme a call
 * and maybe we can work something out.
 *
 * Current email address: cryogen@unix.infoserve.net
 * Phone number: (604) 591-9746
 */

#define PLAYER_MAX_SKILL 256

struct PlrType {
  CHARACTER pCharacter;

  BYTE      pRace;
  BYTE      pClass;
  LWORD     pPractice;
  LWORD     pBank;
  LWORD     pMovePMax;
  LWORD     pPowerPMax;
  WORD      pHunger;
  WORD      pThirst;
  WORD      pIntox;
  WORD      pStr;   /* because of maxes allways use ApplyTotal to these */
  WORD      pDex;
  WORD      pCon;
  WORD      pWis;
  WORD      pInt;

  WORD      pGainHit;   /* determined randomly at some point */
  WORD      pGainMove;
  WORD      pGainPower;
  WORD      pGainPractice;

  WORD      pFame;
  WORD      pInfamy;

  FLAG      pSystem;   /* player system flags, pkiller, thief etc */ 
  STR      *pPassword;
  STR      *pEnter;
  STR      *pExit;
  STR      *pPrompt;
  STR      *pEmail;
  STR      *pPlan;
  STR      *pLastLogin;
  FLAG      pAuto;     /* player autoactions */
  FLAG      pSockPref; /* player socket/comm/channel preferences */
  BYTE      pScreenLines;
  ULWORD    pTimeTotal;
  ULWORD    pTimeLastOn;
  ULWORD    pIdleTick;
  THING    *pIdleRoom;
  LWORD     pStartRoom; /* Room we will reappear in at signon */
  LWORD     pRecallRoom; /* Room we will recall to */
  LWORD     pDeathRoom; /* Room we will go to after we die*/
  WORD      pAttempts;

  WORD      pSkill[PLAYER_MAX_SKILL];

  COLORPREF pColorPref[COLORPREF_MAX];

  FLAG      pSoundPref; /* added by Rich */
};

/* Player system flags */
#define PS_LOG        1<<0
#define PS_KILLER     1<<1 /* get this for killing a player unless other player is a killer */
#define PS_HELPER     1<<2 /* special bit settable only by gods */
#define PS_CRASHSAVED 1<<3 /* are they saved in crash dir */
#define PS_NOHASSLE   1<<4 /* prevent mobs from attacking gods only */
#define PS_GODINVIS   1<<5 /* just what is sounds like */
#define PS_TESTER     1<<6 /* enables some diagnostics added by rich */
#define PS_NOSUMMON   1<<7 /* if set requires a check to be summoned added by rich */
#define PS_NOSPAM     1<<8 /* ignore lower levels trying to tell/beep us added by rich */
#define PS_ENFORCER   1<<9 /* get this for killing a KILLER added by rich */
#define PS_CODER      1<<10 /* enable reboot for level 240+ as cam requested added by rich */
#define PS_SOUND      1<<11 /* enable sounds added by rich */

/* Autoaction/pref flags */
#define PA_AUTOLOOK   1<<0
#define PA_AUTOEXIT   1<<1
#define PA_AUTOLOOT   1<<2
#define PA_AUTOASSIST 1<<3
#define PA_AUTOAGGR   1<<4
#define PA_AUTOJUNK   1<<5
#define PA_AUTOFLEE   1<<6
#define PA_AUTOEAT    1<<7
#define PA_AUTODRINK  1<<8
#define PA_NOEMAIL    1<<9
#define PA_HINT       1<<10
#define PA_EXPERT     1<<11
#define PA_CONSIDER   1<<12
#define PA_AUTORESCUE 1<<13
#define PA_AFK        1<<14

/* Special levels */
/* Note regarding levels:
 * LEVEL_IMMORTAL - Highest "mortal" level regular players can achieve. 
 *                  Players stop getting experience once they get this level.
 * LEVEL_GOD      - Helpers. This class is intended for people who want to
 *                  help other players and generally socialize a bit.
 *                  They can oload, purge, wgoto, and so forth. But they
 *                  cannot create new areas, nor change anyone's stats.
 * LEVEL_STAFF    - Like the name says. MUD Staff. The people who are involved
 *                  in the operations of the MUD. STAFF can create areas, 
 *                  edit C4 scripts, change area editors, and almost 
 *                  everything else. 
 * LEVEL_HIGHSTAFF- Slightly more trusted STAFF
 * LEVEL_ADMIN    - Authority staff. Can see GodInvis gods. Can see 
 *                  player's host IP addresses (via PORT channel, and "users").
 *                  Access to this level represents a security risk for 
 *                  players.
 * LEVEL_SECURITY - Head administrators with security privledges. Can 
 *                  use "log" command to trace other player's actions. Can
 *                  use "reboot" command. Can use "bedit" command. Can use
 *                  "site" command to designate local or banned sites.
 *                  It is assumed this level is held by the head 
 *                  administrator(s) for the MUD. Access to this level 
 *                  represents a security risk for the MUD.
 * LEVEL_CODER    - Full access. Only level able to execute "shutdown" command.
 *                  It is assumed this level is only held by the owners
 *                  of the MUD/server.
 */
#define LEVEL_NEWBIE        1 /* player levels of note */
#define LEVEL_GREEN         4 
#define LEVEL_NOVICE       15 
#define LEVEL_EXPERIENCED  25 
#define LEVEL_VETERAN      40
#define LEVEL_ELITE        60
#define LEVEL_ULTRAELITE   80
#define LEVEL_LEGEND      101 /* wow they're really something now */
#define LEVEL_IMMORTAL    200 
#define LEVEL_GOD         201 /* administrative levels  */
#define LEVEL_STAFF       240 /* trusted "staff" levels */
#define LEVEL_HIGHSTAFF   245 /* higher "staff" levels */
#define LEVEL_ADMIN       250 
#define LEVEL_SECURITY    251
#define LEVEL_CODER       252
#define LEVEL_NOBODY      300

#define LEVEL_MOVETIRING   4
#define LEVEL_HUNGER       5
#define LEVEL_FIGHTTIRING  6

extern LWORD playerIdleTick;
extern INDEX playerIndex;
extern LWORD playerStartRoom;
extern BYTE *pSystemList[];
extern BYTE *pAutoList[];

extern void   PlayerInit(void);
extern THING *PlayerAlloc(BYTE *playerName);

#define PCO_OFFLINE   0
#define PCO_ONLINE    1
extern void   PlayerCountObjects(BYTE *directory, BYTE *playerFileName, LWORD online);

#define PNAME_INVALID 0 
#define PNAME_VALID   1
#define PNAME_IN_USE  2
extern BYTE   PlayerName(BYTE *playerName);

extern THING *PlayerFind(BYTE *playerName);
extern BYTE   PlayerCrashExists(THING *thing); /* remove crash recovery files for this player */
extern BYTE   PlayerCloneExists(THING *thing); /* remove crash recovery files for this player */
extern void   PlayerAddOnline(THING *thing);
extern BYTE   PlayerReadHeader(FILE *playerFile, BYTE *header);

#define PREAD_NORMAL  0 /* first check crash, then player */
#define PREAD_CLONE   1 
#define PREAD_CRASH   2
#define PREAD_PLAYER  3
#define PREAD_SCAN    4 /* Dont read object data */
extern THING *PlayerRead(BYTE *playerName, BYTE mode); /* read the player file and associated data */

extern void   PlayerUpdateTime(THING *player);
#define PWRITE_PLAYER 0
#define PWRITE_CRASH  1
#define PWRITE_CLONE  2
extern void   PlayerWrite(THING *player, BYTE mode); /* write the player file and associated data */
extern void   PlayerFree(THING *thing);
extern void   PlayerIdle();
extern void   PlayerTick();
extern void   PlayerRollAbilities(THING *thing, LWORD reroll);
extern LWORD  PlayerExpNeeded(THING *thing);
extern LWORD  PlayerExpUntilLevel(THING *thing);
extern void   PlayerGainLevel(THING *thing, LWORD message);
extern void   PlayerGainExp(THING *thing, LWORD exp);
extern void   PlayerGainFame(THING *thing, LWORD fame);
extern void   PlayerGainInfamy(THING *thing, LWORD infamy, BYTE *message);
extern LWORD  PlayerIsInfamous(THING *player);
extern void   PlayerDelete(THING *player);
extern BYTE  *PlayerGetLevelDesc(THING *player);
extern void   PlayerResetSkill(THING *thing);

#define Plr(x) ((PLR*)(x))

extern void PlayerKillLinkDead( THING* thing );/* added by rich */
extern void PlayerKillDeathTrap( THING* thing , THING* dest, THING* from ); /* added by rich */
