/*
 * Crimson2 Mud Server
 * All source written/copyright Ryan Haksi 1995 *
 * This source code is proprietary. Use in whole or in part without
 * explicity permission by the author is strictly prohibited
 *
 * Current email address(es): cryogen@infoserve.net
 * Phone number: (604) 591-5295
 *  
 * This File written/copyright Richard Day 2000
 * Current Email: thelvyn@home.net
 * permanent email: atragorn@netscape.net
 *
 * C4 Script Language written/copyright Cam Lesiuk 1995
 * Email: clesiuk@engr.uvic.ca
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "crimson2.h"
#include "ini.h"
#include "index.h"
#include "thing.h"
#include "base.h"
#include "object.h"
#include "macro.h"
#include "str.h"
#include "log.h"
#include "send.h"
#include "edit.h"
#include "history.h"
#include "socket.h"
#include "queue.h"
#include "char.h"
#include "player.h"

#include "sound.h"

WORD SOUND_CLASS_RELOAD=0;
WORD SOUND_CLASS_FIGHT=0;
WORD SOUND_CLASS_HIT=0;
WORD SOUND_CLASS_DEATH=0;
WORD SOUND_CLASS_TELEPORT=0;
WORD SOUND_CLASS_DOOR_OPEN=0;
WORD SOUND_CLASS_DOOR_CLOSE=0;
WORD SOUND_CLASS_DOOR_LOCKED=0;
WORD SOUND_CLASS_SHOPKEEP=0;
WORD SOUND_CLASS_MISC=0;
WORD SOUND_CLASS_EAT=0;
WORD SOUND_CLASS_DRINK=0;

/*
sound # = (room # + dir number) % (max sound for this flag)"

add C4 stuff for
DoorOpen(exit, message) and DoorClose(exit, message) 
DoorLock and DoorUnlock

*/

#define SOUND_MAX_RELOAD      16
#define SOUND_MAX_FIGHT        6
#define SOUND_MAX_HIT          6
#define SOUND_MAX_DEATH        1
#define SOUND_MAX_TELEPORT    -1
#define SOUND_MAX_DOOROPEN    12
#define SOUND_MAX_DOORCLOSE   13
#define SOUND_MAX_DOORLOCKED  30
#define SOUND_MAX_SHOPKEEP    -1
#define SOUND_MAX_MISC         0
#define SOUND_MAX_EAT          1
#define SOUND_MAX_DRINK        1

LWORD soundEnabled=0;
BYTE* soundUrl= { "http://phantom.me.uvic.ca/mud/sound" };
WORD  soundClassCount=0;

SOUNDCLASS soundClass[] = {
  { "fight",      SOUND_MAX_FIGHT   ,   100, 1,  75, &SOUND_CLASS_FIGHT       }, /* misc fight sounds */
  { "hit",        SOUND_MAX_HIT     ,   100, 1,  95, &SOUND_CLASS_HIT         }, /* fight hit sounds */
  { "death",      SOUND_MAX_DEATH   ,   100, 1, 100, &SOUND_CLASS_DEATH       }, /* death sounds */
  { "reload",     SOUND_MAX_RELOAD  ,   100, 1,  85, &SOUND_CLASS_RELOAD      }, /* weapon reload sounds */
  { "teleport",   SOUND_MAX_TELEPORT,   100, 1,  50, &SOUND_CLASS_TELEPORT    }, /* teleport/phantomdoor ect sounds */
  { "open",       SOUND_MAX_DOOROPEN,   100, 1,  55, &SOUND_CLASS_DOOR_OPEN   },
  { "close",      SOUND_MAX_DOORCLOSE,  100, 1,  55, &SOUND_CLASS_DOOR_CLOSE  },
  { "locked",     SOUND_MAX_DOORLOCKED, 100, 4,  60, &SOUND_CLASS_DOOR_LOCKED },
  { "shopkeep",   SOUND_MAX_SHOPKEEP,   100, 1,  50, &SOUND_CLASS_SHOPKEEP    },
  { "misc",       SOUND_MAX_MISC,       100, 1,  25, &SOUND_CLASS_MISC        },
  { "eat",        SOUND_MAX_EAT,        100, 2,  25, &SOUND_CLASS_EAT         },
  { "drink",      SOUND_MAX_DRINK,      100, 2,  25, &SOUND_CLASS_DRINK       },
  { "",           -1,                     0, 0,   0, NULL                     }
};

SOUNDPROC(SoundReload) { /* THING *thing, LWORD sound, LWORD flag */  
  SoundPlay( thing, SOUND_CLASS_RELOAD , sound, flag );
}

SOUNDPROC(SoundFight) { /* THING *thing, LWORD sound, LWORD flag */  
  SoundPlay( thing, SOUND_CLASS_FIGHT, sound, flag );
}

SOUNDPROC(SoundHit) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_HIT, sound, flag );
}

SOUNDPROC(SoundDeath) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_DEATH, sound, flag );
}

SOUNDPROC(SoundTeleport) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_TELEPORT, sound, flag );
}

SOUNDPROC(SoundDoorOpen) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_DOOR_OPEN, sound, flag );
}

SOUNDPROC(SoundDoorClose) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_DOOR_CLOSE, sound, flag );
}

SOUNDPROC(SoundShopKeep) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_SHOPKEEP, sound, flag );
}

SOUNDPROC(SoundMisc) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_MISC, sound, flag );
}

SOUNDPROC(SoundDoorLocked) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_DOOR_LOCKED, sound, flag );
}

SOUNDPROC(SoundEat) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_EAT, sound, flag );
}

SOUNDPROC(SoundDrink) { /* THING *thing, LWORD sound, LWORD flag */
  SoundPlay( thing, SOUND_CLASS_DRINK, sound, flag );
}

void SoundInit( void ) {
  BYTE buf[256];
  soundEnabled=INILWordRead("crimson2.ini","EnableMSP",0);
  if( !soundEnabled) {/*no need to continue*/
    Log(LOG_BOOT, "SoundInit: MSP Disabled! \n");
    return;
  }
  while( soundClass[soundClassCount].sClassName[0] ) {
    *soundClass[soundClassCount].sCheck = soundClassCount;
    soundClassCount++;
  }
  if( *soundUrl ) {
    sprintf( buf, "SoundInit: Download Url = %s\n", soundUrl );
  } else {
    strcpy( buf, "SoundInit: Download Url Disabled!\n" );
  }
  Log(LOG_BOOT, buf );
  sprintf( buf, "SoundInit: %i Sound Classes Defined.\n", soundClassCount );
  Log(LOG_BOOT, buf );
}

LWORD SoundEnabled(void){
  return soundEnabled;
}


void SoundPlay( THING* thing, WORD cls, WORD snd, LWORD Flag ) {
  BYTE   buffer[256];
  BYTE   sound[256];
  THING* room = NULL;
  SOCK*  sock = NULL;
  /*
  first check reasons why we cant do this at all
  */
  if( !SoundEnabled() ) /* no error for this of course, just ignore it */
    return;
  if( cls < 0 || cls >= soundClassCount ) {
    sprintf( buffer, "Invalid Class# %i passed to SoundPlay!\n", cls );
    Log(LOG_ERROR, buffer );
    return;
  }
  if( snd < 0 || snd > soundClass[cls].sMax ) {
    sprintf( buffer,"Invalid Sound# %i for Class %s!\n", snd, soundClass[cls].sClassName );
    Log(LOG_ERROR, buffer );
    return;
  }
  /*
     build soundfile name
  */
  sprintf( sound, "%s/%s%.2i.wav", soundClass[cls].sClassName,soundClass[cls].sClassName, snd );
  /*
     build our string to send
  */
  if( *soundUrl ) {
    sprintf( buffer, "!!SOUND(%s V=%i L=%i P=%i T=%s U=%s/%s)",
           sound,                      /* filename */
           soundClass[cls].sVolume,    /* volume */
           soundClass[cls].sRepeat,    /* number of repeats to do */
           soundClass[cls].sPriority,  /* priority */
           soundClass[cls].sClassName, /* classname */
           soundUrl,                   /* URL */
           sound
            );
  } else {
    sprintf( buffer, "!!SOUND(%s V=%i L=%i P=%i T=%s)",           
           sound,                       /* filename */
           soundClass[cls].sVolume,     /* volume */
           soundClass[cls].sRepeat,     /* number of repeats to do */
           soundClass[cls].sPriority,   /* priority */
           soundClass[cls].sClassName   /* classname */
            );
  }
  if ( thing && thing->tType == TTYPE_WLD)
    room = thing->tContain;
  else if ( thing && thing->tType>=TTYPE_BASE && Base(thing)->bInside)
    room = Base(thing)->bInside->tContain;
  else
    room = NULL;
  for (; room; room = room->tNext) {
    sock = BaseControlFind( room );
    if( sock ) {
      /* check if they can hear */
      if ( ThingCanHear( sock->sHomeThing, NULL ) ) {
        /* check if user has sounds enabled */
        if( BIT(Plr(sock->sHomeThing)->pSystem, PS_SOUND) ) {
          /*
             see if they have this class disabled
          */
          if( BIT( Plr(sock->sHomeThing)->pSoundPref,(1<<cls)) ) {
            /*
              class is ok.
              see if they have this particular one disabled
              do we really need to do this ???
            */
            SendThing( buffer, sock->sHomeThing );
          }
        }
      }
    }
  }
}