/*
 * Crimson2 Mud Server
 * All source written/copyright Ryan Haksi 1995 *
 * This source code is proprietary. Use in whole or in part without
 * explicity permission by the author is strictly prohibited
 *
 * Current email address(es): cryogen@infoserve.net
 * Phone number: (604) 591-5295
 *  
 * This File written/copyright Richard Day 2000
 * Current Email: thelvyn@home.net
 * permanent email: atragorn@netscape.net
 *
 * C4 Script Language written/copyright Cam Lesiuk 1995
 * Email: clesiuk@engr.uvic.ca
 */

#ifndef _CRIMSON2_SOUND_H_
#define _CRIMSON2_SOUND_H_

typedef struct {
  BYTE* sClassName;
  WORD  sMax;       /* maximum allowed sounds for this class */
  WORD  sVolume;    /* the volume level to play the sound at */
  WORD  sRepeat;    /* the number of times to play the sound */
  WORD  sPriority;  /* the priority of the sound  */
  WORD* sCheck;     /* be set by init */
} SOUNDCLASS;
extern SOUNDCLASS soundClass[];

extern WORD SOUND_CLASS_RELOAD;
extern WORD SOUND_CLASS_FIGHT;
extern WORD SOUND_CLASS_HIT;
extern WORD SOUND_CLASS_DEATH;
extern WORD SOUND_CLASS_TELEPORT;
extern WORD SOUND_CLASS_DOOR_OPEN;
extern WORD SOUND_CLASS_DOOR_CLOSE;
extern WORD SOUND_CLASS_DOOR_LOCKED;
extern WORD SOUND_CLASS_SHOPKEEP;
extern WORD SOUND_CLASS_MISC;
extern WORD SOUND_CLASS_EAT;
extern WORD SOUND_CLASS_DRINK;


#define SOUND_DOOR_LOCKED_LOW   0 /* tried to open locked door */
#define SOUND_DOOR_LOCKED_HIGH  9
#define SOUND_DOOR_PICK_LOW    10
#define SOUND_DOOR_PICK_HIGH   19
#define SOUND_DOOR_UNLOCK_LOW  20
#define SOUND_DOOR_UNLOCK_HIGH 29
#define SOUND_CREDIT_LOW   0  /* only one sound for now */
#define SOUND_CREDIT_HIGH  0  /* uses SoundMisc */
#define SOUND_FLAG_RANDOM 1<<1 /* do a random sound */

extern LWORD SoundEnabled( void );/* not sure we even need this outside the sound.c */
extern void SoundInit( void );
extern void SoundPlay( THING* thing, WORD Class, WORD Sound, LWORD Flag );
#define SOUNDPROC(proc) void (proc)(THING *thing, LWORD sound, LWORD flag )
extern SOUNDPROC(SoundReload);
extern SOUNDPROC(SoundFight);
extern SOUNDPROC(SoundHit);
extern SOUNDPROC(SoundDeath);
extern SOUNDPROC(SoundTeleport);
extern SOUNDPROC(SoundDoorOpen);
extern SOUNDPROC(SoundDoorClose);
extern SOUNDPROC(SoundDoorLocked);
extern SOUNDPROC(SoundShopKeep);
extern SOUNDPROC(SoundMisc);
extern SOUNDPROC(SoundEat);
extern SOUNDPROC(SoundDrink);

#endif /* #ifndef _CRIMSON2_SOUND_H_ */