#ifndef __CRIMSON2_TABLE_H__
#define __CRIMSON2_TABLE_H__

#define TABLE_MAX_NAME      64

#define TABLE_FILE          "lib/tablelist.tbl"

#define TABLE_FIELD_BYTE    0 /* text */
#define TABLE_FIELD_SBYTE   1 /* 8bit int */
#define TABLE_FIELD_WORD    2 /* 16bit int */
#define TABLE_FIELD_LWORD   3 /* 32bit int */
#define TABLE_FIELD_FLAG    4 /* flag */

typedef struct TableFieldStruct {
  BYTE        tfName[TABLE_MAX_NAME];/* table name or suffix */
  BYTE        tfType;
  LWORD       tfOffset;
  LWORD       tfSize;
} TABLEFIELD;

typedef struct TableStruct {
  BYTE        tName[TABLE_MAX_NAME];/* table name or suffix */
  BYTE        tFilename[TABLE_MAX_NAME]; /* Filename */
  LWORD       tRecordSize;
  LWORD       tRowMax;
  TABLEFIELD *tFieldList;
  LWORD       tFieldMax;
  BYTE       *tData;
} TABLE;

void       TableInit(void);

/* You cant delete tables, and they are only created during bootup, they can however be
 * edited while the mud is running */
TABLE     *TableAlloc(void);

void       TableCreateFlaglist(BYTE *tableName, BYTE *fList[]);
void       TableCreateTypelist(BYTE *tableName, ULWORD tList, LWORD tListSize);

/* Table fields are only allocated at startup, cant be edited while the mud is running */
TABLE     *TableAllocField(BYTE *tableName);
TABLE     *TableCreateField(BYTE *tableName);

TABLE     *TableFind(BYTE *key);
LWORD      TableFindField(BYTE *key);

void       TableGetField(TABLE *table, LWORD row, LWORD field, BYTE *buf);
void       TableSetField(TABLE *table, LWORD row, LWORD field, BYTE *buf);

TABLE     *TableRead(BYTE *tableName);
void       TableWrite(LWORD tableNum);
void       TableWriteAll(void);

#define    TABLECREATETYPELIST(tKey,tList) TableCreateTypelist(tKey, (ULWORD)tList, sizeof(*tList))
#define    TABLEGETFIELD(table, row, field, buf) TableGetField( TableFind(table), row, TableFindField(field), buf )
#define    TABLESETFIELD(table, row, field, buf) TableSetField( TableFind(table), row, TableFindField(field), buf )

#define    Table(x) ((TABLE*)x)

#endif
